using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Globalization;

using System.IO;
using System.Net;

using System.Threading;

using System.Xml;

using System.Collections;

using System.Diagnostics;

namespace Google_Maps_Download
{
    public partial class GMdl : Form
    {
        public GMdl()
        {
            InitializeComponent();
        }

        public mapURL mu = new mapURL();

        private WebClient wc = new WebClient();
        private Random ran = new Random();

        private int[] GetNumbers(string page, bool compliant2x2)
        {
            int min_zoom = 99;
            int min_x = 999999;
            int min_y = 999999;
            int max_x = -1;
            int max_y = -1;

            if (iBAIDUm.Checked)
            {
                // going to use google zoom, and 'redirect' y

                string baidu_img = "http://mappng.baidu.com/maplite/mapbank/baidu/";
                int start = page.IndexOf(baidu_img);
                while (start != -1)
                {
                    start = start + baidu_img.Length;
                    int zoom = 14 - Int32.Parse(page.Substring(start, page.IndexOf("/", start) - start).Replace("W", "-1")); //int Tl = 14 - zoom; // 12 -> 2
                    if (zoom < min_zoom)
                        min_zoom = zoom;
                    start = page.IndexOf(baidu_img, start);
                }

                string baidu_xy = "http://mappng.baidu.com/maplite/mapbank/baidu/" + (14 - min_zoom).ToString().Replace("-1", "W") + "/";
                start = page.IndexOf(baidu_xy);
                while (start != -1)
                {
                    start = start + baidu_xy.Length;

                    // chi80: it's a little different from zoom 9, the level_2 from 10*10 to 50*50.
                    int multiplier = 10;
                    if (14 - min_zoom >= 9)
                        multiplier = 50;

                    int start2 = start;
                    int end = page.IndexOf("_", start);
                    int x = Int32.Parse(page.Substring(start2, end - start2)) * multiplier;
                    start2 = page.IndexOf("/", start2) + 1;
                    end = page.IndexOf("_", start2);
                    x += Int32.Parse(page.Substring(start2, end - start2)); //int Tx = x; // 15 -> -1 <= x is ok
                    if (x < min_x)
                        min_x = x;
                    if (x > max_x)
                        max_x = x;

                    start2 = page.IndexOf("_", start) + 1;
                    end = page.IndexOf("/", start);
                    int y = Int32.Parse(page.Substring(start2, end - start2)) * multiplier;
                    start2 = page.IndexOf("_", end) + 1;
                    end = page.IndexOf(".", start2);
                    y += Int32.Parse(page.Substring(start2, end - start2));
                    y = System.Convert.ToInt32(Math.Pow(2, 14 - min_zoom + 2)) - y - 1; //int Ty = System.Convert.ToInt32(Math.Pow(2, Tl + 2)) - y - 1; // 10 -> 6
                    if (y < min_y)
                        min_y = y;
                    if (y > max_y)
                        max_y = y;

                    start = page.IndexOf(baidu_xy, start);
                }
            }
            else if (iMAP2GOm.Checked)
            {
                // http://map.sogou.com/new/
                // src=\"http://pic1.go2map.com/seamless/0/174/724/0/0/5_0.GIF\"

                string map2go_img = "http://pic1.go2map.com/seamless/0/174/";
                int start = page.IndexOf(map2go_img);
                while (start != -1)
                {
                    start = start + map2go_img.Length;
                    int zoom = Int32.Parse(page.Substring(start, page.IndexOf("/", start) - start)) - 711; // 0 == 17 in url
                    if (zoom < min_zoom)
                        min_zoom = zoom;
                    start = page.IndexOf(map2go_img, start);
                }

                string map2go_xy = "http://pic1.go2map.com/seamless/0/174/" + (711 + min_zoom).ToString() + "/";
                start = page.IndexOf(map2go_xy);
                while (start != -1)
                {
                    start = start + map2go_xy.Length;
                    start = page.IndexOf("/", start) + 1;
                    start = page.IndexOf("/", start) + 1;

                    // order xy correct?

                    int end = page.IndexOf("_", start);
                    int x = Int32.Parse(page.Substring(start, end - start).Replace("M", "-"));
                    if (x < min_x)
                        min_x = x;
                    if (x > max_x)
                        max_x = x;

                    start = end + 1;
                    end = page.IndexOf(".", start);
                    int y = Int32.Parse(page.Substring(start, end - start).Replace("M", "-"));
                    y = System.Convert.ToInt32(Math.Pow(2, 16 - min_zoom)) - y - 1; //int Ty = System.Convert.ToInt32(Math.Pow(2, Tl + 2)) - y - 1; // 10 -> 6
                    if (y < min_y)
                        min_y = y;
                    if (y > max_y)
                        max_y = y;

                    start = page.IndexOf(map2go_xy, start);
                }

            }
            else
            {
                int start = page.IndexOf("zoom=");
                while (start != -1)
                {
                    start = start + 5;
                    int zoom = Int32.Parse(page.Substring(start, page.IndexOf("\"", start) - start));
                    if (zoom < min_zoom)
                        min_zoom = zoom;
                    start = page.IndexOf("zoom=", start);
                }

                start = page.IndexOf(";x=");
                while (start != -1)
                {
                    start = start + 3;
                    int x = Int32.Parse(page.Substring(start, page.IndexOf("&", start) - start));
                    if (x < min_x && page.Substring(start, page.IndexOf("\"", start) - start).EndsWith("=" + min_zoom.ToString()))
                        min_x = x;
                    if (x > max_x && page.Substring(start, page.IndexOf("\"", start) - start).EndsWith("=" + min_zoom.ToString()))
                        max_x = x;
                    start = page.IndexOf(";y=", start) + 3;
                    int y = Int32.Parse(page.Substring(start, page.IndexOf("&", start) - start));
                    if (y < min_y && page.Substring(start, page.IndexOf("\"", start) - start).EndsWith("=" + min_zoom.ToString()))
                        min_y = y;
                    if (y > max_y && page.Substring(start, page.IndexOf("\"", start) - start).EndsWith("=" + min_zoom.ToString()))
                        max_y = y;
                    start = page.IndexOf(";x=", start);
                }
            }

            int span_x = max_x - min_x + 1;
            int span_y = max_y - min_y + 1;

            if (compliant2x2)
            {
                min_x++;
                min_y++;
                span_x = 2;
                span_y = 2;
            }

            return new int[] { min_zoom, min_x, min_y, span_x, span_y };
        }

        private void bGN_Click(object sender, EventArgs e)
        {
            Mzoom.Text = "";

            try
            {
                int[] the_numbers = GetNumbers(wB.Document.Body.OuterHtml, ComplyToFormat.Checked);

                Mzoom.Text = the_numbers[0].ToString();
                Mx.Text = the_numbers[1].ToString();
                My.Text = the_numbers[2].ToString();
                Mw.Text = the_numbers[3].ToString();
                Mh.Text = the_numbers[4].ToString();

                if (map_name.Text == "")
                {
                    map_name.Text = "_Map of " + Mx.Text + " by " + My.Text + " at " + Mzoom.Text + " to " + Minzoom.Text;
                }
            }
            catch
            {
                MessageBox.Show(msgPreview1.Text);
            }
        }
        
        private string HTMLmapPage(int zoom, int min_x, int min_y, int span_x, int span_y)
        {
            int span = span_x;
            if (span < span_y)
                span = span_y;

            string preview = "<HTML><body><nobr>";
            int y_off = 0;
            while (y_off < span)
            {
                int x_off = 0;
                while (x_off < span)
                {
                    preview = preview + "<IMG width = 256 height = 256 SRC=" + mu.MapByType(zoom, min_x + x_off, min_y + y_off, MapType()) + ">";

                    x_off++;
                }
                preview = preview + "<BR>";
                y_off++;
            }
            preview = preview + "</nobr></body><html>";

            return preview;
        }

        private void bSP_Click(object sender, EventArgs e)
        {
            int x_off;
            int y_off;

            tabs.SelectedTab = tP;

            int span = Int32.Parse(Mw.Text);
            if (span < Int32.Parse(Mh.Text))
                span = Int32.Parse(Mh.Text);

            wP.DocumentText = HTMLmapPage(Int32.Parse(Mzoom.Text), Int32.Parse(Mx.Text), Int32.Parse(My.Text), Int32.Parse(Mw.Text), Int32.Parse(Mh.Text));

            int zoom_multiple = 1;
            for (int i = Int32.Parse(Mzoom.Text); i > Int32.Parse(Minzoom.Text); i--)
            {
                zoom_multiple *= 2;
            }

            int wTLx = Int32.Parse(Mx.Text) * zoom_multiple;
            int wTLy = Int32.Parse(My.Text) * zoom_multiple;

            x_off = span * zoom_multiple - 1;
            y_off = span * zoom_multiple - 1;

            wTL.DocumentText = "<IMG SRC=" + mu.MapByType(Int32.Parse(Minzoom.Text), wTLx, wTLy, MapType()) + ">";
            wBL.DocumentText = "<IMG SRC=" + mu.MapByType(Int32.Parse(Minzoom.Text), wTLx, wTLy + y_off, MapType()) + ">";
            wTR.DocumentText = "<IMG SRC=" + mu.MapByType(Int32.Parse(Minzoom.Text), wTLx + x_off, wTLy, MapType()) + ">";
            wBR.DocumentText = "<IMG SRC=" + mu.MapByType(Int32.Parse(Minzoom.Text), wTLx + x_off, wTLy + y_off, MapType()) + ">";
        }

        private int TotalFiles(int span_w, int span_h, int max_zoom, int min_zoom)
        {
            int span = span_w;
            if (span < span_h)
                span = span_h;

            int zoom_multiple = 1;
            for (int i = max_zoom; i > min_zoom; i--)
            {
                zoom_multiple *= 2;
            }

            int total_files = 0;
            for (int dm = 1; dm <= zoom_multiple; dm *= 2)
            {
                total_files += dm * dm * span * span;
            }

            return total_files;
        }

        private void CheckGoogleSat()
        {
            if (mu.CheckGoogleSatOK() == false)
                MessageBox.Show("Google Satellite tile test failed\n\nMay be an idea to change connection");
        }

        private bool tiles_missed = false;
        private int true_done_files = 0;
        private DataTable missing_tiles = new DataTable();
        private int running_threads = 0;

        private void bPF_Click(object sender, EventArgs e)
        {
            int BAIDUmin = 14 - Int32.Parse(Mzoom.Text);
            int BAIDUmax = 14 - Int32.Parse(Minzoom.Text);
            /*
             * Bad (*2.5 jumps)
             * 9 to 10
             * 6 to 7
             * 3 to 4
            */
            if (iBAIDUm.Checked && ((BAIDUmin < 9.5 && BAIDUmax > 9.5) || (BAIDUmin < 6.5 && BAIDUmax > 6.5) || (BAIDUmin < 3.5 && BAIDUmax > 3.5))) // right comparison? other jumps?
            {
                MessageBox.Show(msgBaiduJump.Text);
            }
            else
            {
                TriggerMapAbort.Checked = false;
                TriggerMapAbort.Visible = true;
                DirectoryInfo map_dir = new DirectoryInfo(map_name.Text);
                if (map_dir.Exists && map_dir.GetFiles().Length + map_dir.GetDirectories().Length > 0 && RepairDir.Checked == false)
                {
                    MessageBox.Show("Already There\n\nnote: if specifying an existing directory it needs to be empty");
                }
                else
                {
                    bool diff_drive = false;
                    if (map_name.Text.Length >= 2) // C:...
                    {
                        if (map_name.Text.Substring(1, 1) == ":") // C:
                        {
                            if (map_name.Text.Substring(0, 1).ToUpper() != Directory.GetCurrentDirectory().Substring(0, 1).ToUpper()) // C vs D
                            {
                                if (RepairDir.Checked == false)
                                {
                                    diff_drive = true;
                                }
                            }
                        }
                    }
                    string dest_dir = map_name.Text;
                    if (LocalGPSFStemp.Checked && diff_drive)
                    {
                        map_name.Text = ran.Next(100000, 999999).ToString();
                        map_dir = new DirectoryInfo(map_name.Text);
                    }

                    tiles_missed = false;

                    int zoom_multiple = 1;
                    for (int i = Int32.Parse(Mzoom.Text); i > Int32.Parse(Minzoom.Text); i--)
                    {
                        zoom_multiple *= 2;
                    }

                    int span = Int32.Parse(Mw.Text);
                    if (span < Int32.Parse(Mh.Text))
                        span = Int32.Parse(Mh.Text);

                    if (zoom_multiple * span > 1024)
                    {
                        MessageBox.Show("Area selected with minimum zoom is too big (" + (zoom_multiple * span).ToString() + " where 1024 max)");
                    }
                    else
                    {
                        DataTable to_skip = new DataTable();
                        to_skip.Columns.Add("zoom", typeof(Int32));
                        to_skip.Columns.Add("x", typeof(Int32));
                        to_skip.Columns.Add("y", typeof(Int32));
                        if (Int32.Parse(Mzoom.Text) - Int32.Parse(Minzoom.Text) > 2 && SelectiveDetail.Checked)
                        {
                            SelectDetail4x detail = new SelectDetail4x(Int32.Parse(Mzoom.Text), Int32.Parse(Minzoom.Text), Int32.Parse(Mx.Text), Int32.Parse(My.Text), MapType(), mu);
                            detail.ShowDialog();
                            while (detail.Visible)
                            {
                                Thread.Sleep(500);
                            }
                            to_skip = detail.TilesToIgnore;
                        }

                        FilesDone.Text = "";

                        if (map_dir.Exists == false)
                            map_dir.Create();

                        int wTLx = Int32.Parse(Mx.Text) * zoom_multiple;
                        int wTLy = Int32.Parse(My.Text) * zoom_multiple;

                        if (NoCoords.Checked == false && new FileInfo(map_name.Text + "/coords.txt").Exists == false)
                        {
                            StreamWriter sr = new StreamWriter(map_name.Text + "/coords.txt");
                            if (iMAP2GOm.Checked)
                                sr.WriteLine(wTLx.ToString() + " " + (System.Convert.ToInt32(Math.Pow(2, 16 - Int32.Parse(Minzoom.Text))) - wTLy - 1).ToString() + " " + (711 + Int32.Parse(Minzoom.Text)).ToString());
                            else
                                sr.WriteLine(wTLx.ToString() + " " + wTLy.ToString() + " " + Minzoom.Text);
                            sr.Close();
                        }

                        missing_tiles.Rows.Clear();

                        try
                        {
                            int done_files = 1;
                            int total_files = TotalFiles(Int32.Parse(Mw.Text), Int32.Parse(Mh.Text), Int32.Parse(Mzoom.Text), Int32.Parse(Minzoom.Text));
                            true_done_files = 0;

                            running_threads = 0;

                            int the_zoom = Int32.Parse(Mzoom.Text);
                            int dir_multiple = 1;
                            for (int dir_zoom = zoom_multiple; dir_zoom >= 1; dir_zoom /= 2, the_zoom--, dir_multiple *= 2)
                            {
                                DirectoryInfo dir_x = new DirectoryInfo(map_name.Text + "/" + dir_zoom.ToString() + "x");
                                if (dir_x.Exists == false)
                                    dir_x.Create();

                                int Zx = Int32.Parse(Mx.Text) * dir_multiple;
                                int Zy = Int32.Parse(My.Text) * dir_multiple;

                                for (int dir_row = 0; dir_row < span * dir_multiple; dir_row++)
                                {
                                    DirectoryInfo dir_num = new DirectoryInfo(map_name.Text + "/" + dir_zoom.ToString() + "x" + "/" + dir_row.ToString("000"));
                                    if (dir_num.Exists == false)
                                        dir_num.Create();

                                    for (int fil_col = 0; fil_col < span * dir_multiple; fil_col++)
                                    {
                                        if (TriggerMapAbort.Checked)
                                        {
                                            int i1 = Int32.Parse("Need an error thrown");
                                        }

                                        if (to_skip.Select("zoom = " + the_zoom.ToString() + " AND x = " + (Zx + fil_col).ToString() + " AND y = " + (Zy + dir_row).ToString()).Length == 0)
                                        {
                                            string part_file_name = dir_zoom.ToString() + "x" + dir_row.ToString("000") + fil_col.ToString("000");
                                            string full_file_name = map_name.Text + "/" + dir_zoom.ToString() + "x" + "/" + dir_row.ToString("000") + "/" + part_file_name + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"));


                                            if (DoThread.Checked)
                                            {
                                                while (running_threads > Int32.Parse(NumThreads.Text))
                                                {
                                                    Thread.Sleep(1);
                                                }
                                                Thread tile_thread = new Thread(new ParameterizedThreadStart(GetThreadTile));
                                                tile_thread.Start(new Object[] { the_zoom, Zx + fil_col, Zy + dir_row, full_file_name });

                                                RunningThreads.Text = running_threads.ToString();
                                                Application.DoEvents();
                                            }
                                            else
                                            {
                                                GetThreadTile(new Object[] { the_zoom, Zx + fil_col, Zy + dir_row, full_file_name });
                                            }

                                            FilesDone.Text = done_files.ToString() + " out of " + (total_files - to_skip.Rows.Count).ToString() + " now at zoom " + dir_zoom.ToString() + "x (got " + true_done_files.ToString() + ")";
                                            Application.DoEvents();
                                            done_files++;
                                        }
                                    }
                                }
                            }

                            // wait for threads to finish up
                            while (running_threads > 0)
                            {
                                Thread.Sleep(5);
                            }

                            if (CopyIcons.Checked && new DirectoryInfo("icons").Exists)
                            {
                                foreach (FileInfo icon in new DirectoryInfo("icons").GetFiles("*.png"))
                                {
                                    if (new FileInfo(map_name.Text + "\\" + icon.Name).Exists == false)
                                    {
                                        icon.CopyTo(map_name.Text + "\\" + icon.Name);
                                    }
                                }
                            }

                            if (missing_tiles.Rows.Count > 0 && PromptToRetryTiles.Checked)
                            {
                                new GMdl_2ndTryDL(missing_tiles.Copy(), mu).ShowDialog();
                            }

                            // top left and bottom right (directories exist)
                            try
                            {
                                if (new FileInfo(map_name.Text + "\\1x\\000\\1x000000" + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).Exists == false)
                                {
                                    new FileInfo("resources\\empty_tile" + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).CopyTo(map_name.Text + "\\1x\\000\\1x000000" + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs")));
                                }
                            }
                            catch { }
                            try
                            {
                                string bottom_right = (Math.Pow(2, 1 + Int32.Parse(Mzoom.Text) - Int32.Parse(Minzoom.Text)) - 1).ToString("000");
                                if (new FileInfo(map_name.Text + "\\1x\\" + bottom_right + "\\1x" + bottom_right + bottom_right + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).Exists == false)
                                {
                                    new FileInfo("resources\\empty_tile" + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).CopyTo(map_name.Text + "\\1x\\" + bottom_right + "\\1x" + bottom_right + bottom_right + mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs")));
                                }
                            }
                            catch { }


                            // empty directories
                            foreach (DirectoryInfo dir_x in new DirectoryInfo(map_name.Text).GetDirectories())
                            {
                                foreach (DirectoryInfo dir_n in dir_x.GetDirectories())
                                {
                                    if (dir_n.GetFiles().Length == 0)
                                        dir_n.Delete();
                                }
                            }

                            
                        }
                        catch
                        {
                            if (RepairDir.Checked == false)
                            {
                                new DirectoryInfo(map_name.Text).Delete(true); // don't delete if repairing
                            }
                            if (show_map_ok)
                                MessageBox.Show(msgPullError.Text);
                            else
                            {
                                int i2 = Int32.Parse("Need an error thrown");
                            }
                        }

                        if (show_map_ok == false && tiles_missed)
                        {
                            int i3 = Int32.Parse("Need an error thrown");
                        }
                    }

                    if (new DirectoryInfo(map_name.Text).Exists) // didn't get deleted by an error thrown
                    {
                        if (NoGPSFS.Checked)
                        {
                            FilesDone.Text = "Finishing up, wait";

                            // directories
                            DirectoryInfo temp_dirDI = new DirectoryInfo(map_name.Text);
                            
                            if (diff_drive) // move?
                            {
                                DirectoryInfo dest_dirDI = new DirectoryInfo(dest_dir);
                                if (dest_dirDI.Exists == false)
                                    dest_dirDI.Create();
                                foreach (FileInfo file in temp_dirDI.GetFiles())
                                {
                                    file.MoveTo(dest_dirDI.FullName + "\\" + file.Name);
                                }
                                foreach (DirectoryInfo file_dir in temp_dirDI.GetDirectories())
                                {
                                    CopyDir.Copy(file_dir.FullName, dest_dirDI.FullName + "\\" + file_dir.Name); // because...
                                }
                                temp_dirDI.Delete(true);
                            }

                            map_name.Text = dest_dir;

                            if (show_map_ok)
                            {
                                if (tiles_missed)
                                    MessageBox.Show("Finished downlaoding the map\nbut there were missed tiles, see ERROR_LOG.txt in the map folder");
                                else
                                    MessageBox.Show("Finished downlaoding the map");
                            }
                        }
                        else
                        {
                            // encode
                            FilesDone.Text = "Creating GPSFS, wait";
                            Application.DoEvents();
                            bool worked = new GPSFS().CreateGPSFS(map_name.Text);

                            if (worked)
                            {
                                // directories
                                DirectoryInfo temp_dirDI = new DirectoryInfo(map_name.Text);
                                new FileInfo(temp_dirDI.FullName + "\\" + "coords.txt").Delete();
                                foreach (DirectoryInfo dir_x in temp_dirDI.GetDirectories())
                                {
                                    dir_x.Delete(true);
                                }
                                if (diff_drive) // move?
                                {
                                    DirectoryInfo dest_dirDI = new DirectoryInfo(dest_dir);
                                    if (dest_dirDI.Exists == false)
                                        dest_dirDI.Create();
                                    foreach (FileInfo file in temp_dirDI.GetFiles())
                                    {
                                        file.MoveTo(dest_dirDI.FullName + "\\" + file.Name);
                                    }
                                    temp_dirDI.Delete();
                                }

                                map_name.Text = dest_dir;

                                if (show_map_ok)
                                {
                                    if (tiles_missed)
                                        MessageBox.Show("Finished downlaoding the map\nbut there were missed tiles, see ERROR_LOG.txt in the map folder" + "\n\nand\n\nGPSFS created");
                                    else
                                        MessageBox.Show("Finished downlaoding the map" + "\n\nand\n\nGPSFS created");
                                }
                            }
                            else
                            {
                                if (show_map_ok)
                                {
                                    MessageBox.Show("Something went wrong, invalid dir, GPSFS already exists, etc.\n\n" + map_name.Text + " + is where it's (temp) at\n\nnever having made it to" + dest_dir + " (if different)");
                                }
                            }
                        }
                    }
                }

                TriggerMapAbort.Checked = false;
                TriggerMapAbort.Visible = false;
            }
        }

        private void GetThreadTile(object Thread_xyz) // static?
        {
            running_threads++;
            Object[] thread_xyz = (Object[])Thread_xyz;
            int thread_z = (int)thread_xyz[0];
            int thread_x = (int)thread_xyz[1];
            int thread_y = (int)thread_xyz[2];
            string full_file_name = (string)thread_xyz[3];

            if (new FileInfo(full_file_name).Exists == false)
            {
                if (WarnOnTileFail.Checked)
                {
                    if (ran.Next(1, 10) == 1)
                    {
                        CheckGoogleSat();
                    }
                }

                if (iT.Checked || iASKt.Checked)
                {
                    Bitmap sat = new Bitmap(1, 1);
                    Bitmap trans = new Bitmap(1, 1);

                    try
                    {
                        sat = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType().Replace("iT", "iS").Replace("iASKt", "iASKs")))));
                    }
                    catch
                    {
                        try
                        {
                            sat = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType().Replace("iT", "iS").Replace("iASKt", "iASKs")))));
                        }
                        catch
                        {
                            try
                            {
                                if (WarnOnTileFail.Checked)
                                    CheckGoogleSat();

                                sat = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType().Replace("iT", "iS").Replace("iASKt", "iASKs")))));
                            }
                            catch { }
                        }
                    }
                    if (sat.Width != 1)
                    {
                        try
                        {
                            trans = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType()))));
                        }
                        catch
                        {
                            try
                            {
                                trans = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType()))));
                            }
                            catch
                            {
                                try
                                {
                                    if (WarnOnTileFail.Checked)
                                        CheckGoogleSat();

                                    trans = new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType()))));
                                }
                                catch { }
                            }
                        }
                    }

                    if (sat.Width != 1 && trans.Width != 1)
                    {

                        Graphics.FromImage(sat).DrawImage(trans, new Rectangle(0, 0, 256, 256), new Rectangle(0, 0, 256, 256), System.Drawing.GraphicsUnit.Pixel);
                        sat.Save(full_file_name);
                        true_done_files++;
                        sat.Dispose();
                        trans.Dispose();
                    }
                    else
                    {
                        if (IgnoreMissingTiles.Checked == false)
                        {
                            if (PromptToRetryTiles.Checked)
                            {
                                // Not implemented, so...
                                int i1 = Int32.Parse("Need an error thrown");
                            }
                            else
                            {
                                int i1 = Int32.Parse("Need an error thrown");
                            }
                        }
                        else
                        {
                            StreamWriter sr2 = new StreamWriter(map_name.Text + "/ERROR_LOG.txt", true);
                            sr2.WriteLine(mu.MapByType(thread_z, thread_x, thread_y, MapType()) + " TO " + full_file_name);
                            sr2.Close();
                            tiles_missed = true;
                        }
                    }
                }
                else
                {
                    true_done_files++;
                    try
                    {
                        if (iBAIDUm.Checked)
                            new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).GetThumbnailImage(256, 256, new Image.GetThumbnailImageAbort(ThumbnailCallback), System.IntPtr.Zero).Save(full_file_name);
                        else if (iMAP2GOm.Checked)
                            new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).Save(full_file_name, System.Drawing.Imaging.ImageFormat.Png);
                        else
                            wc.DownloadFile(mu.MapByType(thread_z, thread_x, thread_y, MapType()), full_file_name);
                    }
                    catch
                    {
                        try
                        {
                            if (iBAIDUm.Checked)
                                new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).GetThumbnailImage(256, 256, new Image.GetThumbnailImageAbort(ThumbnailCallback), System.IntPtr.Zero).Save(full_file_name);
                            else if (iMAP2GOm.Checked)
                                new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).Save(full_file_name, System.Drawing.Imaging.ImageFormat.Png);
                            else
                                wc.DownloadFile(mu.MapByType(thread_z, thread_x, thread_y, MapType()), full_file_name);
                        }
                        catch
                        {
                            try
                            {
                                if (WarnOnTileFail.Checked)
                                    CheckGoogleSat();

                                if (iBAIDUm.Checked)
                                    new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).GetThumbnailImage(256, 256, new Image.GetThumbnailImageAbort(ThumbnailCallback), System.IntPtr.Zero).Save(full_file_name);
                                else if (iMAP2GOm.Checked)
                                    new Bitmap(new MemoryStream(wc.DownloadData(mu.MapByType(thread_z, thread_x, thread_y, MapType())))).Save(full_file_name, System.Drawing.Imaging.ImageFormat.Png);
                                else
                                    wc.DownloadFile(mu.MapByType(thread_z, thread_x, thread_y, MapType()), full_file_name);
                            }
                            catch
                            {
                                true_done_files--;
                                if (IgnoreMissingTiles.Checked == false)
                                {
                                    if (PromptToRetryTiles.Checked)
                                    {
                                        DataRow missed_tile = missing_tiles.NewRow();
                                        missed_tile["URL"] = mu.MapByType(thread_z, thread_x, thread_y, MapType());
                                        missed_tile["File"] = full_file_name;
                                        missing_tiles.Rows.Add(missed_tile);
                                    }
                                    else
                                    {
                                        int i1 = Int32.Parse("Need an error thrown");
                                    }
                                }
                                else
                                {
                                    StreamWriter sr2 = new StreamWriter(map_name.Text + "/ERROR_LOG.txt", true);
                                    sr2.WriteLine(mu.MapByType(thread_z, thread_x, thread_y, MapType()) + " TO " + full_file_name);
                                    sr2.Close();
                                    tiles_missed = true;
                                }
                            }
                        }
                    }
                }
            }
            running_threads--;
        }

        private bool ThumbnailCallback()
        {
            return false;
        }

        private void TBload_Click(object sender, EventArgs e)
        {
            p11.Image = null;
            p12.Image = null;
            p13.Image = null;

            p21.Image = null;
            p22.Image = null;
            p23.Image = null;

            p31.Image = null;
            p32.Image = null;
            p33.Image = null;

            DirectoryInfo td = new DirectoryInfo(tdir.Text);

            if (td.Exists)
            {
                int top_dir = 0;
                foreach (DirectoryInfo dir in td.GetDirectories("*x"))
                {
                    //string top_dir_check = dir.Name;
                    //top_dir_check = top_dir_check.Substring(0, top_dir_check.LastIndexOf("x/"));
                    //top_dir_check = top_dir_check.Substring(top_dir_check.LastIndexOf("/") + 1, top_dir_check.Length - 1 - top_dir_check.LastIndexOf("/"));
                    if (Int32.Parse(dir.Name.Replace("x", "")) > top_dir)
                        top_dir = Int32.Parse(dir.Name.Replace("x", ""));
                }

                if (top_dir > 0)
                {
                    string ext = "png";
                    if (new DirectoryInfo(td.FullName + "/" + top_dir.ToString() + "x" + "/000").GetFiles("*.jpg").Length > 0)
                    {
                        ext = "jpg";
                    }

                    try
                    {
                        p11.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "\\" + top_dir.ToString() + "x" + "\\000\\" + top_dir.ToString() + "x000000." + ext)));
                    }
                    catch { }
                    try
                    {
                        p12.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/000/" + top_dir.ToString() + "x000001." + ext)));
                    }
                    catch { }
                    try
                    {
                        p13.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/000/" + top_dir.ToString() + "x000002." + ext)));
                    }
                    catch { }

                    try
                    {
                        p21.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/001/" + top_dir.ToString() + "x001000." + ext)));
                    }
                    catch { }
                    try
                    {
                        p22.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/001/" + top_dir.ToString() + "x001001." + ext)));
                    }
                    catch { }
                    try
                    {
                        p23.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/001/" + top_dir.ToString() + "x001002." + ext)));
                    }
                    catch { }

                    try
                    {
                        p31.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/002/" + top_dir.ToString() + "x002000." + ext)));
                    }
                    catch { }
                    try
                    {
                        p32.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/002/" + top_dir.ToString() + "x002001." + ext)));
                    }
                    catch { }
                    try
                    {
                        p33.Image = new Bitmap(new MemoryStream(File.ReadAllBytes(td.FullName + "/" + top_dir.ToString() + "x" + "/002/" + top_dir.ToString() + "x002002." + ext)));
                    }
                    catch { }

                }
                else // GPSFS secondary
                {
                    try
                    {
                        p11.Image = new GPSFS().GetGPSFStileReverse(td.FullName, 4);
                    }
                    catch { }
                    try
                    {
                        p12.Image = new GPSFS().GetGPSFStileReverse(td.FullName, 3);
                    }
                    catch { }
                    try
                    {
                        p21.Image = new GPSFS().GetGPSFStileReverse(td.FullName, 2);
                    }
                    catch { }
                    try
                    {
                        p22.Image = new GPSFS().GetGPSFStileReverse(td.FullName, 1);
                    }
                    catch { }
                }
            }
        }

        private void UserMode_Click(object sender, EventArgs e)
        {
            if (AdvancedPanel.Enabled == false)
            {
                UserMode.Text = bAdvSimp.Text;
                AdvancedPanel.Enabled = true;
                MessageBox.Show(msgAdvanced.Text);
            }
            else
            {
                UserMode.Text = bAdvAdv.Text;
                AdvancedPanel.Enabled = false;
            }
        }

        private void EasyMode_Click(object sender, EventArgs e)
        {
            if (map_name.Text == "")
            {
                SetMapDir_Click(Type.Missing, EventArgs.Empty);
            }

            bGN_Click(Type.Missing, EventArgs.Empty);

            if (Mzoom.Text != "")
            {
                bSP_Click(Type.Missing, EventArgs.Empty);
                bPF_Click(Type.Missing, EventArgs.Empty);

                tabs.SelectedTab = tT;

                tdir.Text = map_name.Text;

                TBload_Click(Type.Missing, EventArgs.Empty);
            }
        }

        private bool show_map_ok = true;

        private void bPA_Click(object sender, EventArgs e)
        {
            string orig_name = map_name.Text.Trim();
            int done_ok = 0;

            bool errors = false;

            show_map_ok = false;
            try
            {
                iM.Checked = true;
                map_name.Text = orig_name + " (" + iM .Text+ " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }

            try
            {
                iMSNh.Checked = true;
                map_name.Text = orig_name + " (" + iMSNh.Text + " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }

            /*try
            {
                iT.Checked = true;
                map_name.Text = orig_name + " (" + iT.Text + " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }*/
            try
            {
                iS.Checked = true;
                map_name.Text = orig_name + " (" + iS.Text + " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }

            /*try
            {
                iMSNm.Checked = true;
                map_name.Text = orig_name + " (" + iMSNm.Text + " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }*/

            /*try
            {
                iMSNs.Checked = true;
                map_name.Text = orig_name + " (" + iMSNs.Text + " " + Mzoom.Text + " to " + Minzoom.Text + ")";
                bPF_Click(Type.Missing, EventArgs.Empty);
                done_ok++;
            }
            catch { errors = true; }*/
            show_map_ok = true;

            if (errors)
            {
                if (IgnoreMissingTiles.Checked)
                    MessageBox.Show("Done " + done_ok.ToString() + " sources OK, failed on others, check ERROR_LOG.txt in those map folders" + "\n\nFormatting your Memory Stick as FAT32 on your PC will let you store more maps");
                else
                    MessageBox.Show("Done " + done_ok.ToString() + " sources OK, failed on others, those map folders deleted" + "\n\nFormatting your Memory Stick as FAT32 on your PC will let you store more maps");
            }
            else
                MessageBox.Show("Done " + done_ok.ToString() + " sources OK" + "\n\nFormatting your Memory Stick as FAT32 on your PC will let you store more maps");

            map_name.Text = orig_name;
        }

        private void bPR1_Click(object sender, EventArgs e)
        {
            try
            {
                int[] the_numbers = GetNumbers(wB.Document.Body.OuterHtml, ComplyToFormat.Checked);
                int total_files = TotalFiles(the_numbers[3], the_numbers[4], the_numbers[0], Int32.Parse(Minzoom.Text));
                string page = HTMLmapPage(the_numbers[0], the_numbers[1], the_numbers[2], the_numbers[3], the_numbers[4]);

                new Prev1x(total_files, page, System.Convert.ToInt32(Math.Pow(2, 1 + the_numbers[0] - Int32.Parse(Minzoom.Text))), mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).ShowDialog();
            }
            catch
            {
                MessageBox.Show(msgPreview1.Text);
            }
        }

        private void bPR2_Click(object sender, EventArgs e)
        {
            try
            {
                int[] the_numbers = GetNumbers(wB.Document.Body.OuterHtml, ComplyToFormat.Checked);
                int total_files = TotalFiles(the_numbers[3], the_numbers[4], the_numbers[0], Int32.Parse(Minzoom.Text));
                string page = HTMLmapPage(the_numbers[0] - 1, the_numbers[1] * 2, the_numbers[2] * 2, the_numbers[3] * 2, the_numbers[4] * 2);

                new Prev2x(total_files, page, System.Convert.ToInt32(Math.Pow(2, 1 + the_numbers[0] - Int32.Parse(Minzoom.Text))), mu.ExtByType(MapType().Replace("iT", "iS").Replace("iASKt", "iASKs"))).ShowDialog();
            }
            catch
            {
                MessageBox.Show(msgPreview2.Text);
            }
        }

        private DataTable POI;
        private DataTable DIR;

        private void GMdl_Load(object sender, EventArgs e)
        {
            new Translation().LoadFile(this);

            if (this.Width < 1329 || this.Height < 860)
                this.WindowState = FormWindowState.Maximized;

            POI = new DataTable();
            POI.Columns.Add("Lat", typeof(Decimal));
            POI.Columns.Add("Lon", typeof(Decimal));
            POI.Columns.Add("Name", typeof(String));
            POI.Columns.Add("Icon", typeof(String));
            poiGrid.DataSource = POI;

            DIR = new DataTable();
            DIR.Columns.Add("Lat", typeof(Decimal));
            DIR.Columns.Add("Lon", typeof(Decimal));
            DIR.Columns.Add("Name", typeof(String));
            dirGrid.DataSource = DIR;

            dirDist.SelectedIndex = 1;

            // icons and sizes (pictures in the future maybe)
            if (new DirectoryInfo("icons").Exists)
            {
                foreach (FileInfo icon in new DirectoryInfo("icons").GetFiles("*.png"))
                {
                    //poiImage.Items.Add(icon.Name); // + "," + image.Width.ToString() + "," + image.Height.ToString() + ",");
                    //dirImage.Items.Add(icon.Name); // + "," + image.Width.ToString() + "," + image.Height.ToString() + ",");

                    FileStream image_file = new FileStream(icon.FullName, FileMode.Open);
                    Bitmap image = new Bitmap(image_file);
                    image_file.Close();

                    ToolStripMenuItem ti1 = new ToolStripMenuItem();
                    ti1.Text = icon.Name;
                    ti1.Image = image;
                    poiImage.DropDownItems.Add(ti1);

                    ToolStripMenuItem ti2 = new ToolStripMenuItem();
                    ti2.Text = icon.Name;
                    ti2.Image = image;
                    dirImage.DropDownItems.Add(ti2);
                }
            }

            // the update check
            new UpdateCheck(this.Text);

            // the build version
            string build = System.Windows.Forms.Application.ProductVersion;
            build = build.Substring(build.LastIndexOf(".") + 1, build.Length - 1 - build.LastIndexOf("."));
            this.Text = this.Text + " - Build " + build;

            //the TOS compliance
            new TOScompliance();

            string page = wc.DownloadString("http://maps.google.com");

            string google_mt = "google.com/mt?n=404&v=";
            int start = page.IndexOf(google_mt);
            while (start != -1)
            {
                start += google_mt.Length;
                string google_ver = page.Substring(start, page.IndexOf("&", start) - start);
                if (google_ver.IndexOf("t") != -1)
                    iTversion.Text = google_ver;
                else
                    iMversion.Text = google_ver;
                start = page.IndexOf(google_mt, start);
            }

            missing_tiles.Columns.Add("URL", typeof(String));
            missing_tiles.Columns.Add("File", typeof(String));

            string google_s = "google.com/kh?n=404&v=";
            start = page.IndexOf(google_s);
            while (start != -1)
            {
                start += google_mt.Length;
                string google_ver = page.Substring(start, page.IndexOf("&", start) - start);
                iSversion.Text = google_ver;
                start = page.IndexOf(google_s, start);
            }
        }

        private void ToGoogle_Click(object sender, EventArgs e)
        {
            wDB.Navigate("http://maps.google.com");
        }

        private void ToMSN_Click(object sender, EventArgs e)
        {
            wDB.Navigate("http://local.live.com");
        }

        private void ToText_Click(object sender, EventArgs e)
        {
            wDBtext.Text = wDB.Document.Body.OuterHtml;
        }

        private void ToWB_Click(object sender, EventArgs e)
        {
            wDB.DocumentText = wDBtext.Text;
        }

        private void poiGetNumbers_Click(object sender, EventArgs e)
        {
            try
            {
                string page = wPOI.Document.Body.OuterHtml;

                int start = page.IndexOf("&amp;ll=");

                start = page.IndexOf("=", start) + 1;
                int end = page.IndexOf(",", start);
                poiLat.Text = page.Substring(start, end - start);

                start = end + 1;
                end = page.IndexOf("&", start);
                poiLon.Text = page.Substring(start, end - start);

                start = page.IndexOf("=", start) + 1;
                end = page.IndexOf(",", start);
                poiLatS.Text = page.Substring(start, end - start);

                start = end + 1;
                end = page.IndexOf("&", start);
                poiLonS.Text = page.Substring(start, end - start);
            }
            catch
            {
                MessageBox.Show(msgGetNumbers.Text);
            }
        }

        private void poiList_Click(object sender, EventArgs e)
        {
            if (poiMap24.Checked)
            {
                if (poiAddNotRepl.Checked == false)
                    POI.Rows.Clear();

                try
                {
                    string page = wPOI.Document.Window.Frames[3].Document.Body.InnerHtml;

                    int start = page.IndexOf("addLocation");
                    while (start != -1)
                    {
                        start = page.IndexOf("\"", start) + 1;
                        int end = page.IndexOf("\"", start);
                        // loc num
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start);
                        decimal lon = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo) / 60;
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start);
                        decimal lat = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo) / 60;
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start);
                        // empty
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start);
                        // some num
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start);
                        // empty
                        start = page.IndexOf("\"", end + 1) + 1;
                        end = page.IndexOf("\"", start) - 1;
                        string name_full = page.Substring(start, end - start);

                        string name_name = name_full;
                        try
                        {
                            name_name = name_full.Substring(0, name_full.IndexOf("|")).Trim(); // first
                        }
                        catch { }
                        string name_address = "";
                        try
                        {
                            name_address = name_full.Substring(name_full.IndexOf("|") + 1, name_full.LastIndexOf("|") - 1 - name_full.IndexOf("|")).Replace("|", "; ").Trim();
                        }
                        catch { }
                        string name_phone = "";
                        try
                        {
                            name_phone = name_full.Substring(name_full.LastIndexOf("|") + 1, name_full.Length - 1 - name_full.LastIndexOf("|")).Trim(); // last
                        }
                        catch { }

                        string name = name_name + "\n" + name_phone + " - " + name_address;

                        DataRow new_row = POI.NewRow();
                        new_row["Lat"] = lat;
                        new_row["Lon"] = lon;
                        new_row["Name"] = name.Replace(",", ";");
                        POI.Rows.Add(new_row);

                        start = page.IndexOf("addLocation", start);
                    }

                    MessageBox.Show("There are " + POI.Rows.Count.ToString() + " POIs");
                }
                catch
                {
                    MessageBox.Show(msgPOIerror.Text);
                }
            }
            else
            {
                if (poiSearch.Text.Trim() == "")
                {
                    MessageBox.Show(msgPOIterm.Text);
                }
                else
                {
                    try
                    {
                        if (poiAddNotRepl.Checked == false)
                            POI.Rows.Clear();

                        int yahoo_results = 0;

                        bool max_tripped = false;

                        decimal lat_step = Decimal.Parse(poiLatS.Text, NumberFormatInfo.InvariantInfo) / Decimal.Parse(poiLatDiv.Text, NumberFormatInfo.InvariantInfo);
                        decimal lon_step = Decimal.Parse(poiLonS.Text, NumberFormatInfo.InvariantInfo) / Decimal.Parse(poiLonDiv.Text, NumberFormatInfo.InvariantInfo);

                        decimal lat1a = Decimal.Parse(poiLat.Text, NumberFormatInfo.InvariantInfo) + (decimal)0.5 * Decimal.Parse(poiLatS.Text, NumberFormatInfo.InvariantInfo);
                        decimal lat2a = Decimal.Parse(poiLat.Text, NumberFormatInfo.InvariantInfo) - (decimal)0.5 * Decimal.Parse(poiLatS.Text, NumberFormatInfo.InvariantInfo);

                        decimal lon1a = Decimal.Parse(poiLon.Text, NumberFormatInfo.InvariantInfo) + (decimal)0.5 * Decimal.Parse(poiLonS.Text, NumberFormatInfo.InvariantInfo);
                        decimal lon2a = Decimal.Parse(poiLon.Text, NumberFormatInfo.InvariantInfo) - (decimal)0.5 * Decimal.Parse(poiLonS.Text, NumberFormatInfo.InvariantInfo);

                        decimal lat1 = lat1a;
                        decimal lat2 = lat1 - lat_step;

                        decimal lon1 = lon1a;
                        decimal lon2 = lon1 - lon_step;

                        while (lat2 >= lat2a)
                        {
                            while (lon2 >= lon2a)
                            {
                                bool yahoo_read = false;

                                bool more_left = true;
                                int poi_num = 0;
                                while (more_left)
                                {
                                    int records = 0;
                                    try
                                    {
                                        if (poiMSN.Checked)
                                        {
                                            string url = "http://local.live.com/search.ashx?a=" + poiSearch.Text.Trim() + "&c=" + lat1.ToString("0.000000").Replace(",", ".") + "&d=" + lon1.ToString("0.000000").Replace(",", ".") + "&e=" + lat2.ToString("0.000000").Replace(",", ".") + "&f=" + lon2.ToString("0.000000").Replace(",", ".") + "&g=" + poi_num.ToString() + "&i=2&t=yp&r=true"; // &r=true not required but makes shorter res
                                            string page = wc.DownloadString(url); // i=2 does nothing but seems to be required, can be any number, r=true ensures no adds(?)

                                            int start = page.IndexOf("new VE_SearchResult(");

                                            while (start != -1)
                                            {
                                                start = page.IndexOf("','", start) + 3;
                                                int end = page.IndexOf("','", start);
                                                string loc_name = page.Substring(start, end - start).Replace(",", ";").Trim();
                                                start = end + 3;
                                                end = page.IndexOf("','", start);
                                                string loc_add = page.Substring(start, end - start).Replace(",", ";").Trim();
                                                start = end + 3;
                                                end = page.IndexOf("',", start);
                                                string loc_pho = page.Substring(start, end - start).Replace(",", ";").Trim();
                                                string name = loc_name + "\n" + loc_pho + " - " + loc_add;
                                                while (name.IndexOf("  ") != -1)
                                                {
                                                    name = name.Replace("  ", " ");
                                                }

                                                start = page.IndexOf("',", end + 1) + 2;
                                                end = page.IndexOf(",", start);
                                                decimal lat = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                                                start = end + 1;
                                                end = page.IndexOf(",", start);
                                                decimal lon = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                                                if (POI.Select("Lat = " + lat.ToString("0.000000").Replace(",", ".") + " AND Lon = " + lon.ToString("0.000000").Replace(",", ".") + " AND Name = '" + name.Replace("'", "''") + "'").Length == 0) // the reported dupes
                                                {
                                                    DataRow new_row = POI.NewRow();
                                                    new_row["Lat"] = lat;
                                                    new_row["Lon"] = lon;
                                                    new_row["Name"] = name;
                                                    POI.Rows.Add(new_row);

                                                    records++;
                                                }

                                                start = page.IndexOf("new VE_SearchResult(", start);
                                            }
                                        }
                                        else if (poiYahoo.Checked)
                                        {
                                            string url = "http://xml1.maps.yahoo.com/lsx.xml?stx=" + poiSearch.Text.Trim() + "&lat=" + ((lat1 + lat2) / 2).ToString("0.000000").Replace(",", ".") + "&lon=" + ((lon1 + lon2) / 2).ToString("0.000000").Replace(",", ".") + "&begin=" + (poi_num + 1).ToString() + "&n=25&radius=" + poiYahooMi.Text;

                                            XmlDocument xmlDoc = new XmlDocument();
                                            xmlDoc.Load(url);

                                            foreach (XmlNode res in xmlDoc.GetElementsByTagName("searchtotal"))
                                            {
                                                if (yahoo_read == false)
                                                {
                                                    yahoo_results += Int32.Parse(res.InnerText);
                                                    yahoo_read = true;

                                                    if (Int32.Parse(res.InnerText) > 950)
                                                        max_tripped = true;
                                                }
                                            }

                                            foreach (XmlNode res in xmlDoc.GetElementsByTagName("listing"))
                                            {
                                                string loc_name = "";
                                                string loc_add = "";
                                                string loc_pho = "";
                                                decimal lat = 0;
                                                decimal lon = 0;
                                                foreach (XmlNode res2 in res.ChildNodes)
                                                {
                                                    if (res2.Name == "title")
                                                        loc_name = res2.InnerText.Replace(",", ";");
                                                    if (res2.Name == "addr")
                                                        loc_add = res2.InnerText.Replace(",", ";");
                                                    if (res2.Name == "phone")
                                                        loc_pho = res2.InnerText.Replace(",", ";");

                                                    if (res2.Name == "lat")
                                                        lat = Decimal.Parse(res2.InnerText, NumberFormatInfo.InvariantInfo);
                                                    if (res2.Name == "lon")
                                                        lon = Decimal.Parse(res2.InnerText, NumberFormatInfo.InvariantInfo);
                                                }
                                                loc_name = loc_name.Replace("<b>", "").Replace("</b>", "").Trim();

                                                foreach (XmlNode res2 in res.ChildNodes)
                                                {
                                                    if (res2.Name == "rating")
                                                        if (res2.InnerText != "")
                                                            loc_add = loc_add + " [Rated " + res2.InnerText.Replace(",", ";") + "/5]";
                                                }

                                                string name = loc_name + "\n" + loc_pho + " - " + loc_add;
                                                while (name.IndexOf("  ") != -1)
                                                {
                                                    name = name.Replace("  ", " ");
                                                }

                                                if (POI.Select("Lat = " + lat.ToString("0.000000").Replace(",", ".") + " AND Lon = " + lon.ToString("0.000000").Replace(",", ".") + " AND Name = '" + name.Replace("'", "''") + "'").Length == 0) // the reported dupes
                                                {
                                                    DataRow new_row = POI.NewRow();
                                                    new_row["Lat"] = lat;
                                                    new_row["Lon"] = lon;
                                                    new_row["Name"] = name;
                                                    POI.Rows.Add(new_row);

                                                    records++;
                                                }
                                            }
                                        }
                                        else if (poiGoogle.Checked)
                                        {
                                            string url = "http://" + poiGoogleURL.Text.Trim() + "/maps?output=kml&sll=" + ((lat1 + lat2) / 2).ToString("0.000000").Replace(",", ".") + "," + ((lon1 + lon2) / 2).ToString("0.000000").Replace(",", ".") + "&sspn=" + lat_step.ToString("0.000000").Replace(",", ".") + "," + lon_step.ToString("0.000000").Replace(",", ".") + "&q=" + poiSearch.Text.Trim() + "&start=" + poi_num.ToString();

                                            XmlDocument xmlDoc = new XmlDocument();
                                            xmlDoc.Load(url);

                                            foreach (XmlNode res in xmlDoc.GetElementsByTagName("Placemark"))
                                            {
                                                string loc_name = "";
                                                string loc_desc = "";
                                                decimal lat = 0;
                                                decimal lon = 0;
                                                foreach (XmlNode res2 in res.ChildNodes)
                                                {
                                                    if (res2.Name == "name")
                                                        loc_name = res2.InnerText.Replace(",", ";");
                                                    if (res2.Name == "description")
                                                        loc_desc = res2.InnerText.Replace(",", ";");

                                                    if (res2.Name == "Point")
                                                    {
                                                        foreach (XmlNode res3 in res2.ChildNodes)
                                                        {
                                                            string coord = "";
                                                            if (res3.Name == "coordinates")
                                                                coord = res3.InnerText.Replace(",", "<") + "<";

                                                            lon = Decimal.Parse(coord.Substring(0, coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                                            lat = Decimal.Parse(coord.Substring(coord.IndexOf("<") + 1, coord.IndexOf("<", coord.IndexOf("<") + 1) - 1 - coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                                        }
                                                    }
                                                }

                                                loc_desc = loc_desc + "<";
                                                loc_desc = loc_desc.Replace("<br/><", "<"); // get phone out?
                                                loc_desc = loc_desc.Replace("<br/>", " - "); // get phone out?
                                                if (loc_desc.IndexOf("<") != -1)
                                                    loc_desc = loc_desc.Substring(0, loc_desc.IndexOf("<")).Trim();

                                                string name = loc_name + "\n" + loc_desc;
                                                while (name.IndexOf("  ") != -1)
                                                {
                                                    name = name.Replace("  ", " ");
                                                }
                                                if (POI.Select("Lat = " + lat.ToString("0.000000").Replace(",", ".") + " AND Lon = " + lon.ToString("0.000000").Replace(",", ".") + " AND Name = '" + name.Replace("'", "''") + "'").Length == 0) // the reported dupes
                                                {
                                                    DataRow new_row = POI.NewRow();
                                                    new_row["Lat"] = lat;
                                                    new_row["Lon"] = lon;
                                                    new_row["Name"] = name;
                                                    POI.Rows.Add(new_row);

                                                    records++;
                                                }
                                            }

                                        }
                                    }
                                    catch { }

                                    if (records == 0)
                                    {
                                        more_left = false;
                                    }

                                    if (poiMSN.Checked)
                                        poi_num += 10;
                                    else if (poiYahoo.Checked)
                                        poi_num += 25;
                                    else // if (poiGoogle.Checked)
                                        poi_num += 10;
                                }

                                if (poiMSN.Checked && poi_num >= 230)
                                    max_tripped = true;
                                if (poiGoogle.Checked && poi_num >= 950)
                                    max_tripped = true;

                                lon1 = lon2;
                                lon2 = lon2 - lon_step;
                            }
                            lon1 = lon1a;
                            lon2 = lon1a - lon_step;

                            lat1 = lat2;
                            lat2 = lat2 - lat_step;
                        }

                        string max_error = "";
                        if (max_tripped)
                            max_error = "\n\nThe number of results for at least one of the cells seems to have hit the maximum,\nyou may want to try larger divisors, and therefore smaller radius for Yahoo";

                        MessageBox.Show("There are " + POI.Rows.Count.ToString() + " POIs" + max_error);
                    }
                    catch
                    {
                        MessageBox.Show(msgPOInum.Text);
                    }
                }
            }

            poiSetIconNull();
        }

        private void poiSave_Click(object sender, EventArgs e)
        {
            if (poiName.Text == "")
            {
                string dir = System.IO.Directory.GetCurrentDirectory();

                SaveFileDialog file = new SaveFileDialog();
                file.ShowDialog();

                System.IO.Directory.SetCurrentDirectory(dir);

                if (file.FileName != "")
                {
                    poiName.Text = file.FileName;
                }
            }

            poiSetIconNull();

            int icons = 0;
            string last_icon = "";
            foreach (DataRow poi in POI.Select("", "Icon"))
            {
                if (last_icon != poi["Icon"].ToString())
                {
                    last_icon = poi["Icon"].ToString();
                    icons++;
                }
            }
            if (icons > 10)
            {
                MessageBox.Show("You can have a maximum of 10 different icons per POI file\nyou have " + icons.ToString() + "\nfix this and try again");
            }
            else
            {
                if (poiName.Text.Trim() == "" && poiSearch.Text.Trim() != "")
                {
                    poiName.Text = "_" + poiSearch.Text.Trim().ToUpper();
                }

                if (poiName.Text.Trim() == "" || POI.Rows.Count == 0)
                {
                    MessageBox.Show(msgPOIsave.Text);
                }
                else
                {
                    if (new FileInfo(poiName.Text.Trim()).Exists)
                    {
                        MessageBox.Show(msgPOIthere.Text);
                    }
                    else
                    {
                        try
                        {
                            // poiSplit400
                            int count = -1;
                            string ext_str = "";
                            if (poiSplit400.Checked && POI.Rows.Count > 400)
                            {
                                ext_str = " 1";
                                count = 400;
                            }
                            int ext = 2;

                            last_icon = "";

                            StreamWriter file = new StreamWriter(poiName.Text.Trim() + ext_str);
                            //file.WriteLine("#");
                            //file.WriteLine("!IMAGE:" + poiImage.Text);
                            //file.WriteLine("#");

                            foreach (DataRow poi in POI.Select("", "Icon"))
                            {
                                if (count == 0)
                                {
                                    // new file
                                    file.Close();
                                    file = new StreamWriter(poiName.Text.Trim() + " " + ext.ToString());
                                    last_icon = "";
                                    count = 400;
                                    ext++;
                                }

                                if (last_icon != poi["Icon"].ToString())
                                {
                                    last_icon = poi["Icon"].ToString();
                                    file.WriteLine("!IMAGE:" + last_icon + ",");
                                }

                                file.WriteLine(((decimal)poi["Lat"]).ToString("0.000000").Replace(",", ".") + "," + ((decimal)poi["Lon"]).ToString("0.000000").Replace(",", ".") + "," + poi["Name"].ToString().Replace("\n", ",") + ",");
                                
                                count--;
                            }

                            file.Close();

                            MessageBox.Show("Saved " + poiName.Text.Trim() + " POI file\n\nPlace it into the corresponding map directory");
                        }
                        catch
                        {
                            new FileInfo(poiName.Text.Trim()).Delete();
                            MessageBox.Show(msgPOInosave.Text);
                        }
                    }
                }
            }
        }

        private void dirList_Click(object sender, EventArgs e)
        {
            if ((dirFrom.Text.Trim() == "" || dirTo.Text.Trim() == "") && dirMap24.Checked == false) // google handles no to
            {
                MessageBox.Show(msgDIRfromto.Text);
            }
            else
            {
                try
                {
                    DIR.Rows.Clear();

                    if (dirMSN.Checked)
                    {
                        DataRow last_point = DIR.NewRow();
                        try
                        {
                            string url = "";
                            url = "http://local.live.com/directions.ashx?start=" + dirFrom.Text.Trim() + "&end=" + dirTo.Text.Trim() + "&units=" + dirDist.Text.Substring(0, 1);
                            if (dirShortest.Checked)
                                url = url + "&type=s";
                            string page = wc.DownloadString(url); // i=2 does nothing but seems to be required, can be any number, r=true ensures no adds(?)

                            if (dirFirst.Checked)
                            {
                                if (page.IndexOf("new VE_Location") != -1)
                                {
                                    int posnewVELocation = page.IndexOf("new VE_Location");
                                    int startlatfrom = page.IndexOf("',", posnewVELocation) + 2;
                                    int endlatfrom = page.IndexOf(",", startlatfrom);
                                    Decimal latfrom = Decimal.Parse(page.Substring(startlatfrom, endlatfrom - startlatfrom), NumberFormatInfo.InvariantInfo);

                                    int startlonfrom = page.IndexOf(",", endlatfrom) + 1;
                                    int endlonfrom = page.IndexOf(")", startlonfrom);
                                    Decimal lonfrom = Decimal.Parse(page.Substring(startlonfrom, endlonfrom - startlonfrom), NumberFormatInfo.InvariantInfo);

                                    int posVEDir = page.IndexOf("VE_Directions.Disambiguate", endlonfrom);

                                    posnewVELocation = page.IndexOf("new VE_Location", posVEDir);
                                    int startlatto = page.IndexOf("',", posnewVELocation) + 2;
                                    int endlatto = page.IndexOf(",", startlatto);
                                    Decimal latto = Decimal.Parse(page.Substring(startlatto, endlatto - startlatto), NumberFormatInfo.InvariantInfo);


                                    int startlonto = page.IndexOf(",", endlatto) + 1;
                                    int endlonto = page.IndexOf(")", startlonto);
                                    Decimal lonto = Decimal.Parse(page.Substring(startlonto, endlonto - startlonto), NumberFormatInfo.InvariantInfo);

                                    url = "http://local.live.com/directions.ashx?startlat=" + latfrom.ToString().Replace(",", ".") + "&startlon=" + lonfrom.ToString().Replace(",", ".") + "&endlat=" + latto.ToString().Replace(",", ".") + "&endlon=" + lonto.ToString().Replace(",", ".") + "&units=" + dirDist.Text.Substring(0, 1);
                                    if (dirShortest.Checked)
                                        url = url + "&type=s";

                                    page = wc.DownloadString(url); // i=2 does nothing but seems to be required, can be any number, r=true ensures no adds(?)
                                }
                            }

                            int start = page.IndexOf("new VE_RouteInstruction");
                            int end;

                            string name;
                            decimal lat;
                            decimal lon;

                            while (start != -1)
                            {
                                start = page.IndexOf("('", start) + 2;
                                end = page.IndexOf("',", start);
                                name = page.Substring(start, end - start).Replace(",", ";").Trim();

                                start = end + 2;
                                end = page.IndexOf(",", start);
                                lat = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                                start = end + 1;
                                end = page.IndexOf(",", start);
                                lon = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                                start = end + 1;
                                end = page.IndexOf(")", start);
                                name = page.Substring(start, end - start) + " " + dirDist.Text + "\n" + name; // dist, then info (since now second line is longer)

                                while (name.IndexOf("  ") != -1)
                                {
                                    name = name.Replace("  ", " ");
                                }

                                DataRow new_row = DIR.NewRow();
                                new_row["Lat"] = lat;
                                new_row["Lon"] = lon;
                                new_row["Name"] = name;

                                if (dirInter.Checked)
                                {
                                    if (DIR.Rows.Count > 0)
                                    {
                                        decimal a1 = (decimal)last_point["Lat"];
                                        decimal a2 = (decimal)new_row["Lat"];
                                        decimal o1 = (decimal)last_point["Lon"];
                                        decimal o2 = (decimal)new_row["Lon"];
                                        decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                        decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));
                                        decimal slope = 9999;
                                        try
                                        {
                                            slope = (a2 - a1) / (o2 - o1);
                                        }
                                        catch { }
                                        decimal Drunning = 0;
                                        decimal oC = d / (decimal)Math.Sqrt(System.Convert.ToDouble(slope * slope + 1)); // messes up on negatives
                                        if (o2 - o1 < (decimal)0)
                                        {
                                            oC *= (decimal)-1;
                                        }
                                        decimal aC = slope * oC;
                                        decimal aRunning = 0;
                                        decimal oRunning = 0;
                                        while (Drunning + d * (decimal)1.5 < Dfull)
                                        {
                                            Drunning += d;
                                            aRunning += aC;
                                            oRunning += oC;
                                            DataRow mid_row = DIR.NewRow();
                                            mid_row["Lat"] = a1 + aRunning;
                                            mid_row["Lon"] = o1 + oRunning;
                                            mid_row["Name"] = " ";
                                            if (last_point["Name"].ToString().IndexOf("mi") != -1)
                                            {
                                                string distS = last_point["Name"].ToString();
                                                distS = distS.Substring(0, distS.IndexOf("mi")).Trim();
                                                int b4 = distS.LastIndexOf("\n");
                                                if (b4 < distS.LastIndexOf(" "))
                                                    b4 = distS.LastIndexOf(" ");
                                                if (b4 == -1)
                                                    b4 = 0; // on frst row in the new format
                                                string distsS = distS.Substring(b4, distS.Length - b4);
                                                decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                                mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " mi";
                                            }
                                            if (last_point["Name"].ToString().IndexOf("km") != -1)
                                            {
                                                string distS = last_point["Name"].ToString();
                                                distS = distS.Substring(0, distS.IndexOf("km")).Trim();
                                                int b4 = distS.LastIndexOf("\n");
                                                if (b4 < distS.LastIndexOf(" "))
                                                    b4 = distS.LastIndexOf(" ");
                                                if (b4 == -1)
                                                    b4 = 0; // on frst row in the new format
                                                string distsS = distS.Substring(b4, distS.Length - b4);
                                                decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                                mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " km";
                                            }
                                            mid_row["Name"] = mid_row["Name"].ToString() + "\nMIDPOINT";
                                            DIR.Rows.Add(mid_row);
                                        }
                                    }
                                }
                                last_point = new_row;
                                DIR.Rows.Add(new_row);

                                start = page.IndexOf("new VE_RouteInstruction", start);
                            }

                            start = page.IndexOf("],'") + 3;
                            end = page.IndexOf("'", start);
                            if (end > page.IndexOf(",", start))
                                end = page.IndexOf(",", start);
                            name = page.Substring(start, end - start).Replace(",", ";").Trim();
                            if (name == "")
                                name = "Destination";

                            start = page.IndexOf("[", start) + 1;
                            end = page.IndexOf(",", start);
                            lat = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                            start = end + 1;
                            end = page.IndexOf("]", start);
                            lon = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo);

                            string tot_dist_time;
                            try
                            {
                                start = page.IndexOf("LatLong");
                                tot_dist_time = page.Substring(0, start);
                                start = tot_dist_time.LastIndexOf("'");
                                tot_dist_time = tot_dist_time.Substring(0, start);
                                tot_dist_time = tot_dist_time.Replace("'mi'", "mi").Replace("'km'", "km").Replace("'q'", "-");
                                tot_dist_time = tot_dist_time.Substring(tot_dist_time.LastIndexOf("',"), tot_dist_time.Length - tot_dist_time.LastIndexOf("',"));
                                tot_dist_time = tot_dist_time.Replace(",", " ").Replace("'", "");
                                while (tot_dist_time.IndexOf("  ") != -1)
                                {
                                    tot_dist_time = tot_dist_time.Replace("  ", " ");
                                }
                                tot_dist_time = tot_dist_time.Trim();
                            }
                            catch
                            {
                                tot_dist_time = "";
                            }

                            DataRow new_rowF = DIR.NewRow();
                            new_rowF["Lat"] = lat;
                            new_rowF["Lon"] = lon;
                            new_rowF["Name"] = tot_dist_time + "\n" + "Arrive at " + name;

                            if (dirInter.Checked) // same code (new_rowF inst new_row, not setting last_point) - midpoints to end
                            {
                                if (DIR.Rows.Count > 0)
                                {
                                    decimal a1 = (decimal)last_point["Lat"];
                                    decimal a2 = (decimal)new_rowF["Lat"];
                                    decimal o1 = (decimal)last_point["Lon"];
                                    decimal o2 = (decimal)new_rowF["Lon"];
                                    decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                    decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));
                                    decimal slope = 9999;
                                    try
                                    {
                                        slope = (a2 - a1) / (o2 - o1);
                                    }
                                    catch { }
                                    decimal Drunning = 0;
                                    decimal oC = d / (decimal)Math.Sqrt(System.Convert.ToDouble(slope * slope + 1)); // messes up on negatives
                                    if (o2 - o1 < (decimal)0)
                                    {
                                        oC *= (decimal)-1;
                                    }
                                    decimal aC = slope * oC;
                                    decimal aRunning = 0;
                                    decimal oRunning = 0;
                                    while (Drunning + d * (decimal)1.5 < Dfull)
                                    {
                                        Drunning += d;
                                        aRunning += aC;
                                        oRunning += oC;
                                        DataRow mid_row = DIR.NewRow();
                                        mid_row["Lat"] = a1 + aRunning;
                                        mid_row["Lon"] = o1 + oRunning;
                                        mid_row["Name"] = " ";
                                        if (last_point["Name"].ToString().IndexOf("mi") != -1)
                                        {
                                            string distS = last_point["Name"].ToString();
                                            distS = distS.Substring(0, distS.IndexOf("mi")).Trim();
                                            int b4 = distS.LastIndexOf("\n");
                                            if (b4 < distS.LastIndexOf(" "))
                                                b4 = distS.LastIndexOf(" ");
                                            if (b4 == -1)
                                                b4 = 0; // on frst row in the new format
                                            string distsS = distS.Substring(b4, distS.Length - b4);
                                            decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                            mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " mi";
                                        }
                                        if (last_point["Name"].ToString().IndexOf("km") != -1)
                                        {
                                            string distS = last_point["Name"].ToString();
                                            distS = distS.Substring(0, distS.IndexOf("km")).Trim();
                                            int b4 = distS.LastIndexOf("\n");
                                            if (b4 < distS.LastIndexOf(" "))
                                                b4 = distS.LastIndexOf(" ");
                                            if (b4 == -1)
                                                b4 = 0; // on frst row in the new format
                                            string distsS = distS.Substring(b4, distS.Length - b4);
                                            decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                            mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " km";
                                        }
                                        mid_row["Name"] = mid_row["Name"].ToString() + "\nMIDPOINT";
                                        DIR.Rows.Add(mid_row);
                                    }
                                }
                            }
                            //last_point = new_row;
                            DIR.Rows.Add(new_rowF);
                        }
                        catch { }
                    }
                    else if (dirGoogle.Checked)
                    {
                        DataRow last_point = DIR.NewRow();

                        string url = "http://" + dirGoogleURL.Text.Trim() + "/maps?output=kml&saddr=" + dirFrom.Text.Trim().Replace(" ", "+") + "&daddr=" + dirTo.Text.Trim().Replace(" ", "+");
                        
                        XmlDocument xmlDoc = new XmlDocument();
                        xmlDoc.Load(url);

                        foreach (XmlNode res in xmlDoc.GetElementsByTagName("Placemark"))
                        {
                            string loc_name = "";
                            string loc_desc = "";
                            decimal lat = 0;
                            decimal lon = 0;
                            foreach (XmlNode res2 in res.ChildNodes)
                            {
                                if (res2.Name == "name")
                                    loc_name = res2.InnerText.Replace(",", ";");
                                if (res2.Name == "description")
                                    loc_desc = res2.InnerText.Replace(",", ".");

                                if (res2.Name == "Point")
                                {
                                    foreach (XmlNode res3 in res2.ChildNodes)
                                    {
                                        string coord = "";
                                        if (res3.Name == "coordinates")
                                            coord = res3.InnerText.Replace(",", "<") + "<";

                                        lon = Decimal.Parse(coord.Substring(0, coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                        lat = Decimal.Parse(coord.Substring(coord.IndexOf("<") + 1, coord.IndexOf("<", coord.IndexOf("<") + 1) - 1 - coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                    }
                                }
                            }

                            loc_desc = loc_desc.Substring(loc_desc.LastIndexOf(" ") + 1, loc_desc.Length - 1 - loc_desc.LastIndexOf(" ")).Trim();
                            loc_desc = loc_desc.Replace("&#160;", " "); // bold

                            string name = loc_desc + "\n" + loc_name;
                            while (name.IndexOf("  ") != -1)
                            {
                                name = name.Replace("  ", " ");
                            }

                            if (lat != 0 || lon != 0)
                            {
                                DataRow new_row = DIR.NewRow();
                                new_row["Lat"] = lat;
                                new_row["Lon"] = lon;
                                new_row["Name"] = name;
                                last_point = new_row;
                                DIR.Rows.Add(new_row);
                            }
                            else 
                            {
                                // add the route
                                foreach (XmlNode res2 in res.ChildNodes)
                                {
                                    if (res2.Name == "description")
                                    {
                                        string end_desc = res2.InnerText.Replace(",", ".");
                                        end_desc = end_desc.Replace("&#160;", " "); // bold
                                        if (end_desc.IndexOf("<") != -1)
                                            end_desc = end_desc.Substring(0, end_desc.IndexOf("<")).Trim();
                                        if (end_desc.IndexOf(":") != -1)
                                            end_desc = end_desc.Substring(end_desc.IndexOf(":") + 1, end_desc.Length - 1 - end_desc.IndexOf(":")).Trim();
                                        last_point["Name"] = end_desc + last_point["Name"].ToString();
                                    }
                                    if (dirInterPath.Checked)
                                    {
                                        if (res2.Name == "GeometryCollection")
                                        {
                                            DataTable DIRbu = DIR.Copy();
                                            DIR.Rows.Clear();

                                            foreach (XmlNode res3 in res2.ChildNodes)
                                            {
                                                if (res3.Name == "LineString")
                                                {
                                                    foreach (XmlNode res4 in res3.ChildNodes)
                                                    {
                                                        string coord = "";
                                                        if (res4.Name == "coordinates")
                                                            coord = res4.InnerText.Trim();

                                                        // lat,lon,ignore
                                                        int start = 0;
                                                        while (start != -1)
                                                        {
                                                            if (start != 0)
                                                                start++;

                                                            int end = coord.IndexOf(",", start);
                                                            lon = Decimal.Parse(coord.Substring(start, end - start), NumberFormatInfo.InvariantInfo);
                                                            start = end + 1;
                                                            end = coord.IndexOf(",", start);
                                                            lat = Decimal.Parse(coord.Substring(start, end - start), NumberFormatInfo.InvariantInfo);
                                                            start = coord.IndexOf(" ", end);

                                                            DataRow new_row = DIR.NewRow();
                                                            if (DIRbu.Select("Lat = " + lat.ToString("0.000000").Replace(",", ".") + " AND Lon = " + lon.ToString("0.000000").Replace(",", ".")).Length == 0) // the actual points
                                                            {
                                                                new_row["Lat"] = lat;
                                                                new_row["Lon"] = lon;
                                                                new_row["Name"] = "PATH" + "\nMIDPOINT";
                                                            }
                                                            else // a waypoint
                                                            {
                                                                foreach (DataRow actual_point in DIRbu.Select("Lat = " + lat.ToString("0.000000").Replace(",", ".") + " AND Lon = " + lon.ToString("0.000000").Replace(",", ".")))
                                                                {
                                                                    new_row["Lat"] = actual_point["Lat"];
                                                                    new_row["Lon"] = actual_point["Lon"];
                                                                    new_row["Name"] = actual_point["Name"];

                                                                    actual_point.Delete();
                                                                }
                                                            }

                                                            //last_point = new_row;
                                                            DIR.Rows.Add(new_row);
                                                        }
                                                    }
                                                }
                                            }
                                            if (DIRbu.Rows.Count == 1)
                                            {
                                                DataRow new_row = DIR.NewRow();
                                                new_row["Lat"] = DIRbu.Rows[0]["Lat"];
                                                new_row["Lon"] = DIRbu.Rows[0]["Lon"];
                                                new_row["Name"] = DIRbu.Rows[0]["Name"];

                                                //last_point = new_row;
                                                DIR.Rows.Add(new_row);
                                            }
                                            else
                                            {
                                                foreach (DataRow actual_point in DIRbu.Rows)
                                                {
                                                    DIR.Rows.Add(actual_point.ItemArray);
                                                }
                                                MessageBox.Show(msgDIRmissing.Text);
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if (dirInterValue.Text.Trim() != "")
                        {
                            if (dirInter.Checked)
                            {
                                DataTable DIRbu = DIR.Copy();
                                DIR.Rows.Clear();

                                foreach (DataRow row in DIRbu.Rows)
                                {
                                    if (DIR.Rows.Count > 0)
                                    {
                                        decimal a1 = (decimal)last_point["Lat"];
                                        decimal a2 = (decimal)row["Lat"];
                                        decimal o1 = (decimal)last_point["Lon"];
                                        decimal o2 = (decimal)row["Lon"];
                                        decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                        decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));
                                        decimal slope = 9999;
                                        try
                                        {
                                            slope = (a2 - a1) / (o2 - o1);
                                        }
                                        catch { }
                                        decimal Drunning = 0;
                                        decimal oC = d / (decimal)Math.Sqrt(System.Convert.ToDouble(slope * slope + 1)); // messes up on negatives
                                        if (o2 - o1 < (decimal)0)
                                        {
                                            oC *= (decimal)-1;
                                        }
                                        decimal aC = slope * oC;
                                        decimal aRunning = 0;
                                        decimal oRunning = 0;
                                        while (Drunning + d * (decimal)1.5 < Dfull)
                                        {
                                            Drunning += d;
                                            aRunning += aC;
                                            oRunning += oC;
                                            DataRow mid_row = DIR.NewRow();
                                            mid_row["Lat"] = a1 + aRunning;
                                            mid_row["Lon"] = o1 + oRunning;
                                            mid_row["Name"] = " " + "\nMIDPOINT";
                                            DIR.Rows.Add(mid_row);
                                        }
                                    }

                                    DIR.Rows.Add(row.ItemArray);
                                    last_point = row;
                                }
                            }

                            // set distances
                            DIR.Columns.Add("Drunning", typeof(Decimal));
                            DIR.Columns.Add("Dtot", typeof(Decimal));
                            DataRow tot_point = DIR.NewRow();
                            bool first_point = true;
                            foreach (DataRow row in DIR.Rows)
                            {
                                row["Drunning"] = 0;

                                if (first_point == false)
                                {
                                    decimal a1 = (decimal)last_point["Lat"];
                                    decimal a2 = (decimal)row["Lat"];
                                    decimal o1 = (decimal)last_point["Lon"];
                                    decimal o2 = (decimal)row["Lon"];
                                    decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                    decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));

                                    if (last_point["Name"].ToString().IndexOf("MIDPOINT") != -1)
                                    {
                                        row["Drunning"] = (decimal)last_point["Drunning"] + Dfull;
                                        tot_point["Dtot"] = (decimal)row["Drunning"];
                                    }
                                    else
                                    {
                                        tot_point = last_point;
                                        row["Drunning"] = Dfull;
                                    }
                                }
                                else
                                {
                                    tot_point = row;
                                }

                                first_point = false;
                                last_point = row;
                            }

                            // point dist * (Dtot - Drunning) / Dtot

                            first_point = true;
                            foreach (DataRow row in DIR.Rows)
                            {
                                if (first_point == false)
                                {
                                    if (row["Name"].ToString().IndexOf("MIDPOINT") != -1)
                                    {
                                        string dist_str = tot_point["Name"].ToString().ToUpper();
                                        if (dist_str.IndexOf(" KM\n") != -1 || dist_str.IndexOf(" MI\n") != -1)
                                        {

                                            decimal dist_val = Decimal.Parse(dist_str.Substring(0, dist_str.IndexOf(" ")));

                                            string dist_ext = "mi";
                                            if (dist_str.IndexOf(" KM\n") != -1)
                                                dist_ext = "km";

                                            row["Name"] = (dist_val * ((decimal)tot_point["Dtot"] - (decimal)row["Drunning"]) / (decimal)tot_point["Dtot"]).ToString("0.0") + " " + dist_ext + "\nMIDPOINT";
                                        }
                                    }
                                    else
                                    {
                                        tot_point = row;
                                    }
                                }
                                else
                                {
                                    tot_point = row;
                                }

                                first_point = false;
                            }

                            if (dirInterRemRed.Checked)
                            {
                                DataTable DIRbu = DIR.Copy();
                                DIR.Rows.Clear();

                                foreach (DataRow row in DIRbu.Rows)
                                {
                                    if (DIR.Rows.Count > 0 && row["Name"].ToString().IndexOf("MIDPOINT") != -1)
                                    {
                                        decimal a1 = (decimal)last_point["Lat"];
                                        decimal a2 = (decimal)row["Lat"];
                                        decimal o1 = (decimal)last_point["Lon"];
                                        decimal o2 = (decimal)row["Lon"];
                                        decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                        decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));

                                        if (Dfull * (decimal)1.5 > d)
                                        {
                                            if ((decimal)row["Drunning"] + d * (decimal)0.5 < (decimal)tot_point["Dtot"]) // not too close to end
                                            {
                                                DIR.Rows.Add(row.ItemArray);
                                                last_point = row;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        DIR.Rows.Add(row.ItemArray);
                                        last_point = row;

                                        tot_point = row;
                                    }
                                }
                            }

                            DIR.Columns.Remove("Drunning");
                            DIR.Columns.Remove("Dtot");
                        }
                    }
                    else if (dirMap24.Checked)
                    {
                        DataRow last_point = DIR.NewRow();

                        string page = wDIR.Document.Window.Frames[3].Document.Body.InnerHtml;

                        int start = page.IndexOf("ctrlShowRouteSeg");
                        start = page.IndexOf("ctrlShowRouteSeg", start + 1);
                        while (start != -1)
                        {
                            start = page.IndexOf("'", start) + 1;
                            int end = page.IndexOf("'", start);
                            decimal lon = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo) / 60;
                            start = page.IndexOf("'", end + 1) + 1;
                            end = page.IndexOf("'", start);
                            decimal lat = Decimal.Parse(page.Substring(start, end - start), NumberFormatInfo.InvariantInfo) / 60;
                            start = page.IndexOf("'", end + 1) + 1;
                            end = page.IndexOf("'", start);
                            // end lon
                            start = page.IndexOf("'", end + 1) + 1;
                            end = page.IndexOf("'", start);
                            // end lat
                            start = page.IndexOf(">", start) + 1;
                            end = page.IndexOf("</DIV", start);
                            string name_full = page.Substring(start, end - start).Replace("<SIGN>", "").Replace("</SIGN>", "").Replace("<B>", "").Replace("</B>", "").Replace(" .", ".").Trim();
                            start = page.IndexOf("</TD>", end) + 5;
                            end = page.IndexOf("</TR>", start);
                            string name_dist = page.Substring(start, end - start).Replace("\r", "").Replace("\n", "").Replace("<TD class=rlr2>", "").Replace("</TD>", "").Replace("<BR>", " - ");
                            if (name_dist == "")
                                name_dist = " ";
                            string name_time = " ";
                            if (name_dist.IndexOf("-") != -1)
                            {
                                name_time = name_dist.Substring(0, name_dist.IndexOf("-")).Trim();
                                name_dist = name_dist.Substring(name_dist.IndexOf("-") + 1, name_dist.Length - 1 - name_dist.IndexOf("-")).Trim();
                            }

                            string name = dirMap24dt.Text.Replace("$D$", name_dist).Replace("$T$", name_time) + "\n" + name_full;

                            DataRow new_row = DIR.NewRow();
                            new_row["Lat"] = lat;
                            new_row["Lon"] = lon;
                            new_row["Name"] = name.Replace(",", ";");

                            if (dirInter.Checked)
                            {
                                if (DIR.Rows.Count > 0)
                                {
                                    decimal a1 = (decimal)last_point["Lat"];
                                    decimal a2 = (decimal)new_row["Lat"];
                                    decimal o1 = (decimal)last_point["Lon"];
                                    decimal o2 = (decimal)new_row["Lon"];
                                    decimal d = Decimal.Parse(dirInterValue.Text, NumberFormatInfo.InvariantInfo);
                                    decimal Dfull = (decimal)Math.Sqrt(System.Convert.ToDouble((a2 - a1) * (a2 - a1) + (o2 - o1) * (o2 - o1)));
                                    decimal slope = 9999;
                                    try
                                    {
                                        slope = (a2 - a1) / (o2 - o1);
                                    }
                                    catch { }
                                    decimal Drunning = 0;
                                    decimal oC = d / (decimal)Math.Sqrt(System.Convert.ToDouble(slope * slope + 1)); // messes up on negatives
                                    if (o2 - o1 < (decimal)0)
                                    {
                                        oC *= (decimal)-1;
                                    }
                                    decimal aC = slope * oC;
                                    decimal aRunning = 0;
                                    decimal oRunning = 0;

                                    while (Drunning + d * (decimal)1.5 < Dfull)
                                    {
                                        Drunning += d;
                                        aRunning += aC;
                                        oRunning += oC;
                                        DataRow mid_row = DIR.NewRow();
                                        mid_row["Lat"] = a1 + aRunning;
                                        mid_row["Lon"] = o1 + oRunning;

                                        // name_dist - keep a record of running
                                        mid_row["Name"] = " ";
                                        /*if (last_point["Name"].ToString().IndexOf("mi") != -1)
                                        {
                                            string distS = last_point["Name"].ToString();
                                            distS = distS.Substring(0, distS.IndexOf("mi")).Trim();
                                            int b4 = distS.LastIndexOf("\n");
                                            if (b4 < distS.LastIndexOf(" "))
                                                b4 = distS.LastIndexOf(" ");
                                            if (b4 == -1)
                                                b4 = 0; // on frst row in the new format
                                            string distsS = distS.Substring(b4, distS.Length - b4);
                                            decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                            mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " mi";
                                        }
                                        if (last_point["Name"].ToString().IndexOf("km") != -1)
                                        {
                                            string distS = last_point["Name"].ToString();
                                            distS = distS.Substring(0, distS.IndexOf("km")).Trim();
                                            int b4 = distS.LastIndexOf("\n");
                                            if (b4 < distS.LastIndexOf(" "))
                                                b4 = distS.LastIndexOf(" ");
                                            if (b4 == -1)
                                                b4 = 0; // on frst row in the new format
                                            string distsS = distS.Substring(b4, distS.Length - b4);
                                            decimal dist = Decimal.Parse(distsS, NumberFormatInfo.InvariantInfo);
                                            mid_row["Name"] = (dist - dist * Drunning / Dfull).ToString("0.0").Replace(",", ".") + " km";
                                        }*/
                                        mid_row["Name"] = mid_row["Name"].ToString() + "\nMIDPOINT";
                                        DIR.Rows.Add(mid_row);
                                    }
                                }
                            }

                            if (dirMap24DupeLL.Checked == false || DIR.Select("Lat = " + new_row["Lat"].ToString().Replace(",", ".") + " AND Lon = " + new_row["Lon"].ToString().Replace(",", ".")).Length == 0)
                            {
                                last_point = new_row;
                                DIR.Rows.Add(new_row);
                            }

                            start = page.IndexOf("ctrlShowRouteSeg", start);
                            if (start != -1)
                                start = page.IndexOf("ctrlShowRouteSeg", start + 1);
                        }
                    }

                    MessageBox.Show("There are " + DIR.Rows.Count.ToString() + " POIs");
                }
                catch
                {
                    MessageBox.Show(msgDIRerror.Text);
                }
            }
        }

        private void SetdirName()
        {
            if (dirName.Text.Trim() == "" && dirFrom.Text.Trim() != "" && dirTo.Text.Trim() != "")
            {
                string from = dirFrom.Text.Trim();
                if (from.IndexOf(",") != -1)
                {
                    from = from.Substring(0, from.IndexOf(",")).Trim();
                }
                string to = dirTo.Text.Trim();
                if (to.IndexOf(",") != -1)
                {
                    to = to.Substring(0, to.IndexOf(",")).Trim();
                }
                dirName.Text = "_" + from.ToUpper() + " TO " + to.ToUpper();
            }
        }

        private void dirSave_Click(object sender, EventArgs e)
        {
            if (dirName.Text == "")
            {
                string dir = System.IO.Directory.GetCurrentDirectory();

                SaveFileDialog file = new SaveFileDialog();
                file.ShowDialog();

                System.IO.Directory.SetCurrentDirectory(dir);

                if (file.FileName != "")
                {
                    dirName.Text = file.FileName;
                }
            }

            SetdirName();

            if (dirName.Text.Trim() == "" || DIR.Rows.Count == 0)
            {
                MessageBox.Show(msgDIRnosave.Text);
            }
            else
            {
                if (new FileInfo(dirName.Text.Trim()).Exists)
                {
                    MessageBox.Show(msgDIRexists.Text);
                }
                else
                {
                    try
                    {
                        // dirSplit400
                        int count = -1;
                        string ext_str = "";
                        if (dirSplit400.Checked && DIR.Rows.Count > 400)
                        {
                            ext_str = " 1";
                            count = 400;
                        }
                        int ext = 2;

                        StreamWriter file = new StreamWriter(dirName.Text.Trim() + ext_str);
                        file.WriteLine("#");
                        file.WriteLine("!IMAGE:" + dirImage.Text + ",");
                        file.WriteLine("!WAYPOINT");
                        file.WriteLine("#");

                        foreach (DataRow poi in DIR.Rows)
                        {
                            if (count == 0)
                            {
                                // new file
                                file.Close();
                                file = new StreamWriter(dirName.Text.Trim() + " " + ext.ToString());
                                file.WriteLine("#");
                                file.WriteLine("!IMAGE:" + dirImage.Text + ",");
                                file.WriteLine("!WAYPOINT");
                                file.WriteLine("#");
                                count = 400;
                                ext++;
                            }

                            file.WriteLine(((decimal)poi["Lat"]).ToString("0.000000").Replace(",", ".") + "," + ((decimal)poi["Lon"]).ToString("0.000000").Replace(",", ".") + "," + poi["Name"].ToString().Replace("\n", ",") + ",");

                            count--;
                        }

                        file.Close();

                        MessageBox.Show("Saved " + dirName.Text.Trim() + " POI file\n\nPlace it into the corresponding map directory");
                    }
                    catch
                    {
                        new FileInfo(dirName.Text.Trim()).Delete();
                        MessageBox.Show(msgDIRsaveerror.Text);
                    }
                }
            }
        }

        private void dirGetValues_Click(object sender, EventArgs e)
        {
            if (dirMSN.Checked)
            {
                try
                {
                    string page = wDIR.Document.Body.OuterHtml;

                    int start = page.IndexOf("ClearSetStartValues");
                    start = page.IndexOf(">", start) + 1;
                    int end = page.IndexOf("<", start);
                    dirFrom.Text = page.Substring(start, end - start).Trim();

                    start = page.IndexOf("ClearSetEndValues");
                    start = page.IndexOf(">", start) + 1;
                    end = page.IndexOf("<", start);
                    dirTo.Text = page.Substring(start, end - start).Trim();

                    if (page.IndexOf("routeType_shortest") < page.IndexOf("CHECKED"))
                        dirShortest.Checked = true;
                    else
                        dirQuickest.Checked = true;

                    if (page.IndexOf("km)") != -1)
                        dirDist.Text = "km";
                    else
                        dirDist.Text = "mi";
                }
                catch
                {
                    MessageBox.Show(msgDIRvalerror.Text);
                }
            }
            else if (dirGoogle.Checked)
            {
                try
                {
                    string page = wDIR.Document.Body.OuterHtml;

                    int start = page.IndexOf("name=saddr");
                    start = page.Substring(0, start).LastIndexOf("value=") + 6;
                    int end = page.IndexOf("name=", start);
                    dirFrom.Text = page.Substring(start, end - start).Replace("\"", " ").Trim();

                    start = page.IndexOf("name=daddr");
                    start = page.Substring(0, start).LastIndexOf("value=") + 6;
                    end = page.IndexOf("name=", start);
                    dirTo.Text = page.Substring(start, end - start).Replace("\"", " ").Trim(); ;
                    
                }
                catch
                {
                    MessageBox.Show(msgDIRvalerror.Text);
                }
            }
            else if (dirMap24.Checked)
            {
                MessageBox.Show(msgDIRvalerror24.Text);
            }
        }

        private void dirInterValueOpt_TextChanged(object sender, EventArgs e)
        {
            dirInterValue.Text = dirInterValueOpt.Text.Substring(dirInterValueOpt.Text.IndexOf("[") + 1, dirInterValueOpt.Text.IndexOf("]") - dirInterValueOpt.Text.IndexOf("[") - 1);

            dirInter.Checked = true;

            DIR.Rows.Clear();

            /*if (dirName.Text == "" || dirName.Text.IndexOf("[") != -1)
            {
                dirName.Text = "";
                SetdirName();
                dirName.Text = dirName.Text + dirInterValueOpt.Text.Replace("Zoom ", "; Z");
            }*/
        }

        private string MapType()
        {
            foreach (Control cn in SelectedMap.Controls)
            {
                try
                {
                    if (((RadioButton)cn).Checked)
                        return cn.Name;
                }
                catch { } // for non checkboxes
            }

            return "";
        }

        private void dDetail_Click(object sender, EventArgs e)
        {
            new SelectDetail4x(Int32.Parse(Mzoom.Text), Int32.Parse(Minzoom.Text), Int32.Parse(Mx.Text), Int32.Parse(My.Text), MapType(), mu).ShowDialog();
        }

        private void NumbersFromLatLon_Click(object sender, EventArgs e)
        {
            LatLonToTiles latlon = new LatLonToTiles(Mzoom.Text);
            latlon.ShowDialog();
            while (latlon.Visible)
            {
                Thread.Sleep(500);
            }
            if (latlon.Mzoom.Text != "")
            {
                Mzoom.Text = latlon.Mzoom.Text;
                Mx.Text = latlon.Mx.Text;
                My.Text = latlon.My.Text;

                if (Mw.Text == "")
                    Mw.Text = "2";
                if (Mh.Text == "")
                    Mh.Text = "2";

                if (map_name.Text == "")
                {
                    map_name.Text = "_Map of " + Mx.Text + " by " + My.Text + " at " + Mzoom.Text + " to " + Minzoom.Text;
                }
            }
        }

        private void poiKML_Click(object sender, EventArgs e)
        {
            if (poiAddNotRepl.Checked == false)
            {
                POI.Rows.Clear();
                poiName.Text = "";
            }

            string dir = System.IO.Directory.GetCurrentDirectory();

            OpenFileDialog file = new OpenFileDialog();
            file.Filter = "KML File - Google (*.kml)|*.kml";
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.FileName != "")
            {
                try
                {
                    string file_name = new FileInfo(file.FileName).Name;
                    file_name = file_name.Substring(0, file_name.LastIndexOf(".")).Trim();
                    if (poiName.Text == "")
                        poiName.Text = "_" + file_name;

                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.Load(file.FileName);

                    foreach (XmlNode res in xmlDoc.GetElementsByTagName("Placemark"))
                    {
                        string loc_name = "";
                        string loc_desc = "";
                        decimal lat = 0;
                        decimal lon = 0;
                        foreach (XmlNode res2 in res.ChildNodes)
                        {
                            if (res2.Name == "name")
                                loc_name = res2.InnerText.Replace(",", ";");
                            if (res2.Name == "description")
                                loc_desc = res2.InnerText.Replace(",", ";");

                            if (res2.Name == "Point")
                            {
                                foreach (XmlNode res3 in res2.ChildNodes)
                                {
                                    string coord = "";
                                    if (res3.Name == "coordinates")
                                        coord = res3.InnerText.Replace(",", "<") + "<";

                                    lon = Decimal.Parse(coord.Substring(0, coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                    lat = Decimal.Parse(coord.Substring(coord.IndexOf("<") + 1, coord.IndexOf("<", coord.IndexOf("<") + 1) - 1 - coord.IndexOf("<")), NumberFormatInfo.InvariantInfo);
                                }
                            }
                        }

                        loc_desc = loc_desc + "<";
                        loc_desc = loc_desc.Replace("<br/><", "<"); // get phone out?
                        loc_desc = loc_desc.Replace("<br/>", " - "); // get phone out?
                        if (loc_desc.IndexOf("<") != -1)
                            loc_desc = loc_desc.Substring(0, loc_desc.IndexOf("<")).Trim();

                        string name = loc_name + "\n" + loc_desc;
                        while (name.IndexOf("  ") != -1)
                        {
                            name = name.Replace("  ", " ");
                        }

                        DataRow new_row = POI.NewRow();
                        new_row["Lat"] = lat;
                        new_row["Lon"] = lon;
                        new_row["Name"] = name;
                        POI.Rows.Add(new_row);
                    }

                    MessageBox.Show("There are " + POI.Rows.Count.ToString() + " POIs");
                }
                catch
                {
                    MessageBox.Show(msgPOIfileerror.Text);
                }
            }

            poiSetIconNull();
        }

        private void poiCSV_Click(object sender, EventArgs e)
        {
            if (poiAddNotRepl.Checked == false)
            {
                POI.Rows.Clear();
                poiName.Text = "";
            }

            string dir = System.IO.Directory.GetCurrentDirectory();

            OpenFileDialog file = new OpenFileDialog();
            file.Filter = "CSV File - Navman, Garmin, generic (*.csv)|*.csv";
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.FileName != "")
            {
                try
                {
                    string file_name = new FileInfo(file.FileName).Name;
                    file_name = file_name.Substring(0, file_name.LastIndexOf(".")).Trim();
                    if (poiName.Text == "")
                        poiName.Text = "_" + file_name;

                    StreamReader csv_file = new StreamReader(file.FileName);
                    while (csv_file.EndOfStream == false)
                    {
                        try
                        {
                            string line = csv_file.ReadLine() + ",,"; // 2nd col and end if not there
                            string loc_name = "";
                            string loc_desc = "";
                            decimal lat = 0;
                            decimal lon = 0;

                            int start = 0;
                            int end = line.IndexOf(",");

                            lon = Decimal.Parse(line.Substring(start, end - start), NumberFormatInfo.InvariantInfo);
                            start = end + 1;
                            end = line.IndexOf(",", start);
                            lat = Decimal.Parse(line.Substring(start, end - start), NumberFormatInfo.InvariantInfo);
                            start = end + 1;
                            end = line.IndexOf(",", start);
                            loc_name = line.Substring(start, end - start).Trim();
                            start = end + 1;
                            end = line.IndexOf(",", start);
                            loc_desc = line.Substring(start, end - start).Trim();

                            if (loc_desc == "" && poiNewline.Checked && poiNewlineText.Text != "")
                            {
                                // divide up name
                                if (loc_name.IndexOf(poiNewlineText.Text) != -1)
                                {
                                    int startNL;
                                    if (poiNewlineFirst.Checked)
                                        startNL = loc_name.IndexOf(poiNewlineText.Text);
                                    else
                                        startNL = loc_name.LastIndexOf(poiNewlineText.Text);

                                    loc_desc = loc_name.Substring(startNL + poiNewlineText.Text.Length, loc_name.Length - startNL - poiNewlineText.Text.Length);
                                    loc_name = loc_name.Substring(0, startNL);
                                }
                            }

                            string name = loc_name + "\n" + loc_desc;

                            name = name.Replace(",", ";").Replace("\"", "");
                            while (name.IndexOf("  ") != -1)
                            {
                                name = name.Replace("  ", " ");
                            }

                            DataRow new_row = POI.NewRow();
                            new_row["Lat"] = lat;
                            new_row["Lon"] = lon;
                            new_row["Name"] = name;
                            POI.Rows.Add(new_row);
                        }
                        catch{}
                    }

                    MessageBox.Show("There are " + POI.Rows.Count.ToString() + " POIs");
                }
                catch
                {
                    MessageBox.Show(msgPOIfileerror.Text);
                }
            }

            poiSetIconNull();
        }

        private void dirGoogle_CheckedChanged(object sender, EventArgs e)
        {
            dirSourceChanged();
        }

        private void dirSourceChanged()
        {
            dirInterValueOpt.Enabled = true;
            dirInterValue.Enabled = true;
            dirFirst.Enabled = true;

            dirQorS.Enabled = true;
            dirDist.Enabled = true;

            dirFrom.Enabled = true;
            dirTo.Enabled = true;
            dirGetValues.Enabled = true;

            dirMap24dt.Enabled = false;

            dirInterRemRed.Enabled = false;
            dirInterPath.Enabled = false;

            dirMap24DupeLL.Enabled = false;

            if (dirMSN.Checked)
            {
                wDIR.Navigate("http://local.live.com");
            }
            else if (dirGoogle.Checked)
            {
                wDIR.Navigate("http://" + dirGoogleURL.Text);

                dirFirst.Enabled = false;

                dirQorS.Enabled = false;
                dirDist.Enabled = false;

                dirInterRemRed.Enabled = true;
                dirInterPath.Enabled = true;
            }
            else if (dirMap24.Checked)
            {
                wDIR.Navigate("http://www." + dirMap24URL.Text);

                dirFirst.Enabled = false;

                dirQorS.Enabled = false;
                dirDist.Enabled = false;

                dirFrom.Enabled = false;
                dirTo.Enabled = false;
                dirGetValues.Enabled = false;

                dirMap24dt.Enabled = true;

                dirMap24DupeLL.Enabled = true;
            }            
        }

        private void dirGoogleURL_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (dirGoogle.Checked)
                wDIR.Navigate("http://" + dirGoogleURL.Text);
        }

        private void poiOV2_Click(object sender, EventArgs e)
        {
            if (poiAddNotRepl.Checked == false)
            {
                POI.Rows.Clear();
                poiName.Text = "";
            }

            string dir = System.IO.Directory.GetCurrentDirectory();

            OpenFileDialog file = new OpenFileDialog();
            file.Filter = "OV2 File - TomTom (*.ov2)|*.ov2";
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.FileName != "")
            {
                try
                {
                    string file_name = new FileInfo(file.FileName).Name;
                    file_name = file_name.Substring(0, file_name.LastIndexOf(".")).Trim();
                    if (poiName.Text == "")
                        poiName.Text = "_" + file_name;

                    #region somewhat borrowed code, somewhat translated with c-sharpener for vb
                    // variables
                    byte[] btHexFile = null;
                    int c = 0; // compteur
                    string loc_name = "";
                    int iLength = 0;
                    int poi_type;

                    btHexFile = System.IO.File.ReadAllBytes(file.FileName);

                    while (c < btHexFile.Length)
                    {
                        poi_type = Convert.ToInt32(btHexFile[c]);
                        while (poi_type != 2 && poi_type != 3) // simple or extended (ignores extended part, untested) record
                        {
                            if (poi_type == 1) // skipper record
                                c += 21;
                            poi_type = Convert.ToInt32(btHexFile[c]);
                        }

                        decimal lat = 0;
                        decimal lon = 0;

                        // rcupration de la longeur du POI
                        iLength = BitConverter.ToInt32(btHexFile, c + 1); // longeur 1 octet; position 2ime octets de chaque POI

                        // ------------------------------
                        // recuperation de la description (X octets; octet de dbut 14ime; octet de fin: iLenght (longeur totale de chaque POI)
                        // ------------------------------
                        loc_name = "";
                        int i = (c + 13);
                        while (i < c + iLength && Convert.ToInt32(btHexFile[i]) != 0)
                        {
                            loc_name += Convert.ToChar(Convert.ToInt32(btHexFile[i]));
                            i++;
                        }

                        // ------------------------------
                        // rcuperation de la longitude (4 octets; position du 6ime au 9ime octets dans chaque POI)
                        // ------------------------------
                        int lon_i = BitConverter.ToInt32(btHexFile, c + 5);
                        lon = System.Convert.ToDecimal(lon_i) / 100000;

                        // ------------------------------
                        // recuperation de la latitude (idem pour la latitude sur 4 octets; du 10ime au 13ime)
                        // ------------------------------
                        int lat_i = BitConverter.ToInt32(btHexFile, c + 9);
                        lat = System.Convert.ToDecimal(lat_i) / 100000;

                        // compteurs
                        c += iLength; // du pointeur dans le fichier

                        string loc_desc = "";
                        if (poiNewline.Checked && poiNewlineText.Text != "")
                        {
                            // divide up name
                            if (loc_name.IndexOf(poiNewlineText.Text) != -1)
                            {
                                int startNL;
                                if (poiNewlineFirst.Checked)
                                    startNL = loc_name.IndexOf(poiNewlineText.Text);
                                else
                                    startNL = loc_name.LastIndexOf(poiNewlineText.Text);

                                loc_desc = loc_name.Substring(startNL + poiNewlineText.Text.Length, loc_name.Length - startNL - poiNewlineText.Text.Length);
                                loc_name = loc_name.Substring(0, startNL);
                            }
                        }

                        string name = loc_name + "\n" + loc_desc;

                        name = name.Replace(",", ";").Replace("\"", "");
                        while (name.IndexOf("  ") != -1)
                        {
                            name = name.Replace("  ", " ");
                        }

                        DataRow new_row = POI.NewRow();
                        new_row["Lat"] = lat;
                        new_row["Lon"] = lon;
                        new_row["Name"] = name;
                        POI.Rows.Add(new_row);
                    }
                    #endregion
                    
                    MessageBox.Show("There are " + POI.Rows.Count.ToString() + " POIs");
                }
                catch
                {
                    MessageBox.Show(msgPOIfileerror.Text);
                }
            }

            poiSetIconNull();
        }

        private void poiSetIconSel_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewCell cell in poiGrid.SelectedCells)
            {
                cell.OwningRow.Cells["Icon"].Value = poiImage.Text;
            }
        }

        private void poiSetIconNull()
        {
            foreach (DataRow row in POI.Select("Icon IS null"))
            {
                row["Icon"] = poiImage.Text;
            }
        }

        private void popCustomMap_Click(object sender, EventArgs e)
        {
            new CustomMap(mu).Show();
        }

        private void IgnoreMissingTiles_CheckedChanged(object sender, EventArgs e)
        {
            if (IgnoreMissingTiles.Checked)
            {
                PromptToRetryTiles.Checked = false;
                PromptToRetryTiles.Enabled = false;
            }
            else
            {
                if (iT.Checked == false && iASKt.Checked == false)
                {
                    PromptToRetryTiles.Enabled = true;
                }
            }
        }

        private void ToMap24_Click(object sender, EventArgs e)
        {
            wDB.Navigate("http://www.map24.com");
        }

        private void ToTextFrameN_Click(object sender, EventArgs e)
        {
            try
            {
                wDBtext.Text = wDB.Document.Window.Frames[Int32.Parse(FrameN.Text)].Document.Body.InnerHtml;
            }
            catch
            {
                wDBtext.Text = "No such frame";
            }
        }

        private void dirMap24URL_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (dirMap24.Checked)
                wDIR.Navigate("http://www." + dirMap24URL.Text);
        }

        private void dirMSN_CheckedChanged(object sender, EventArgs e)
        {
            dirSourceChanged();
        }

        private void dirMap24_CheckedChanged(object sender, EventArgs e)
        {
            dirSourceChanged();
        }

        private void poiMSN_CheckedChanged(object sender, EventArgs e)
        {
            poiSourceChanged();
        }

        private void poiGoogle_CheckedChanged(object sender, EventArgs e)
        {
            poiSourceChanged();
        }

        private void poiYahoo_CheckedChanged(object sender, EventArgs e)
        {
            poiSourceChanged();
        }

        private void poiMap24_CheckedChanged(object sender, EventArgs e)
        {
            poiSourceChanged();
        }

        private void poiSourceChanged()
        {
            poiNumberPanel.Enabled = true;
            poiYahooMi.Enabled = false;

            if (poiMap24.Checked)
            {
                wPOI.Navigate("http://www." + poiMap24URL.Text);

                poiNumberPanel.Enabled = false;
            }
            else
            {
                if (wPOI.Url.ToString().StartsWith("http://maps.google.com") == false)
                    wPOI.Navigate("http://maps.google.com");

                if (poiYahoo.Checked)
                {
                    poiYahooMi.Enabled = true;
                }
            }
        }

        private void poiMap24URL_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (poiMap24.Checked)
                wPOI.Navigate("http://www." + poiMap24URL.Text);
        }

        private void iT_CheckedChanged(object sender, EventArgs e)
        {
            TransChanged();

            SatChanged();

            if (iT.Checked)
                IgnoreMissingTiles.Checked = true;
            else
                IgnoreMissingTiles.Checked = false;
        }

        private void iASKt_CheckedChanged(object sender, EventArgs e)
        {
            TransChanged();
        }

        private void TransChanged()
        {
            PromptToRetryTiles.Checked = true;
            PromptToRetryTiles.Enabled = true;

            if (iT.Checked || iASKt.Checked)
            {
                MessageBox.Show(msgNoHybPrev.Text);

                PromptToRetryTiles.Checked = false;
                PromptToRetryTiles.Enabled = false;
            }
        }

        private void iBAIDUm_CheckedChanged(object sender, EventArgs e)
        {
            MapNavPageChange();
        }

        private void iMAP2GOm_CheckedChanged(object sender, EventArgs e)
        {
            MapNavPageChange();
        }

        private void MapNavPageChange()
        {
            Minzoom.Text = "0";

            CopyIcons.Checked = true;

            NoCoords.Checked = false;
            NoCoords.Enabled = true;

            if (iBAIDUm.Checked)
            {
                wB.Navigate("http://map.baidu.com");
                MessageBox.Show(msgBaidu.Text);

                Minzoom.Text = "2";
                CopyIcons.Checked = false;

                NoCoords.Checked = true;
                NoCoords.Enabled = false;
            }
            else if (iMAP2GOm.Checked)
            {
                wB.Navigate("http://map.sogou.com/new/");
                MessageBox.Show(map2goMsg.Text);
            }
            else
            {
                wB.Navigate("http://maps.google.com");
            }
            
            //bGN_Click(Type.Missing, EventArgs.Empty);
        }

        private void ManualWebLink_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process proc = new Process();
            proc.StartInfo.FileName = ManualWebLink.Text;
            proc.Start();
        }

        private void poiReplace_Click(object sender, EventArgs e)
        {
            if ((poiReplaceB.Text + poiReplaceA.Text).IndexOf(",") != -1)
            {
                MessageBox.Show(msgPOIchars.Text);
            }
            else
            {
                foreach (DataRow row in POI.Rows)
                {
                    row["Name"] = row["Name"].ToString().Replace(poiReplaceA.Text, poiReplaceB.Text);
                }
            }
        }

        private void dirReplace_Click(object sender, EventArgs e)
        {
            if ((dirReplaceB.Text + dirReplaceA.Text).IndexOf(",") != -1)
            {
                MessageBox.Show(msgPOIchars.Text);
            }
            else
            {
                foreach (DataRow row in DIR.Rows)
                {
                    row["Name"] = row["Name"].ToString().Replace(dirReplaceA.Text, dirReplaceB.Text);
                }
            }
        }

        private void poiReplaceGerman_Click(object sender, EventArgs e)
        {
            //   with oe  with ae  with ue and  with ss
            poiReplaceA.Text = "";
            poiReplaceB.Text = "oe";
            poiReplace_Click(Type.Missing, EventArgs.Empty);
            poiReplaceA.Text = "";
            poiReplaceB.Text = "ae";
            poiReplace_Click(Type.Missing, EventArgs.Empty);
            poiReplaceA.Text = "";
            poiReplaceB.Text = "ue";
            poiReplace_Click(Type.Missing, EventArgs.Empty);
            poiReplaceA.Text = "";
            poiReplaceB.Text = "ss";
            poiReplace_Click(Type.Missing, EventArgs.Empty);
        }

        private void dirReplaceGerman_Click(object sender, EventArgs e)
        {
            //   with oe  with ae  with ue and  with ss
            dirReplaceA.Text = "";
            dirReplaceB.Text = "oe";
            dirReplace_Click(Type.Missing, EventArgs.Empty);
            dirReplaceA.Text = "";
            dirReplaceB.Text = "ae";
            dirReplace_Click(Type.Missing, EventArgs.Empty);
            dirReplaceA.Text = "";
            dirReplaceB.Text = "ue";
            dirReplace_Click(Type.Missing, EventArgs.Empty);
            dirReplaceA.Text = "";
            dirReplaceB.Text = "ss";
            dirReplace_Click(Type.Missing, EventArgs.Empty);
        }

        private void SetMapDir_Click(object sender, EventArgs e)
        {
            string dir = System.IO.Directory.GetCurrentDirectory();

            FolderBrowserDialog file = new FolderBrowserDialog();
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.SelectedPath != "")
            {
                map_name.Text = file.SelectedPath;
            }
        }

        private void GenerateTranslation_Click(object sender, EventArgs e)
        {
            if (new FileInfo("translation.txt").Exists)
            {
                MessageBox.Show(msgTransEx.Text);
            }
            else
            {
                new Translation().GenerateFile(this);
                MessageBox.Show(msgTransGen.Text);
            }
        }

        private void ToGPSFS_Click(object sender, EventArgs e)
        {
            bool worked = new GPSFS().CreateGPSFS(map_name.Text);

            if (worked)
                MessageBox.Show(msgGPFcreated.Text);
            else
                MessageBox.Show(msgGPFerror.Text);
        }

        private void FromGPSFS_Click(object sender, EventArgs e)
        {
            bool worked = new GPSFS().ExtractGPSFS(map_name.Text);

            if (worked)
                MessageBox.Show(msgGPFextracted.Text);
            else
                MessageBox.Show(msgGPFexerror.Text);
        }

        private void poiImage_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            Bitmap image = new Bitmap(e.ClickedItem.Image);

            poiImage.Text = e.ClickedItem.Text;
            poiImage.Image = image;
        }

        private void dirImage_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            Bitmap image = new Bitmap(e.ClickedItem.Image);

            dirImage.Text = e.ClickedItem.Text;
            dirImage.Image = image;
        }

        private void FromOldGPSFS_Click(object sender, EventArgs e)
        {
            bool worked = new GPSFS().ExtractOldGPSFS(map_name.Text);

            if (worked)
                MessageBox.Show(msgGPFextracted.Text);
            else
                MessageBox.Show(msgGPFexerror.Text);
        }

        private void iMversion_TextChanged(object sender, EventArgs e)
        {
            mu.iMversion = iMversion.Text;
        }

        private void iTversion_TextChanged(object sender, EventArgs e)
        {
            mu.iTversion = iTversion.Text;
        }

        private void iSversion_TextChanged(object sender, EventArgs e)
        {
            mu.iSversion = iSversion.Text;
        }

        private void iS_CheckedChanged(object sender, EventArgs e)
        {
            SatChanged();
        }

        private void SatChanged()
        {
            if (iT.Checked || iS.Checked)
            {
                WarnOnTileFail.Enabled = true;
                WarnOnTileFail.Checked = true;
            }
            else
            {
                WarnOnTileFail.Enabled = false;
                WarnOnTileFail.Checked = false;
            }
        }

        private void GoogleMapsString_Click(object sender, EventArgs e)
        {
            wDBtext.Text = wc.DownloadString("http://maps.google.com");
        }

        private void RepairDir_CheckedChanged(object sender, EventArgs e)
        {
            if (RepairDir.Checked)
            {
                LocalGPSFStemp.Enabled = false;
                LocalGPSFStemp.Checked = false;

                MessageBox.Show("You need to have the individual files, and specify the zoom,x,y,minzoom\n\nSo extract GPSFS first and use the contents of GPSFS_Extracted");
            }
            else
            {
                LocalGPSFStemp.Enabled = true;
                LocalGPSFStemp.Checked = true;
            }
        }

        private void DoThread_CheckedChanged(object sender, EventArgs e)
        {
            if (DoThread.Checked)
            {
                MessageBox.Show("Threading is experimental, and only seems to benefit slower sites/connections (satellite)" 
                    + "\n\nmake sure check prompt to retry or ignore missing, else you will likely crash" 
                    + "\n\ntiles will fail more frequently with this setup");
            }
        }

        private void RefreshWeb_Click(object sender, EventArgs e)
        {
            wB.Refresh();
        }


        



        // msn route?
        // http://www.elsewhere.org/GMapToGPX/gmaptogpx.js --- has elevation for points (USE!!!)
        // http://badsegue.org/samples/msngpxripdiv.js --- any route ideas?
        // http://badsegue.org/samples/googgpxripdiv.js

        // http://www.viavirtualearth.com/VVE/Articles/Directions.ashx
        // One thing that is missing is the ability to plot the path of the route along the roads.
        // This is more complicated than simply drawing lines between the points as roads are generally not that straight.
        // If you require functionality such as plotting the lines you can either delve deeper into the local.live.com directions code or
        // (and I would recommend this) explore a product such as
        // MapPoint Web Service (http://msdn.microsoft.com/MapPoint) that provides this functionality.

        /* To Do:
         * 
         * calc yahoo mile radius
         * 
         * msn birds eye view (all 4 dir's?)
         * 
         * if max'd auto scroll to top left
         * 
         * better local browser/tester
         * 
         * nasa as source
         *
         * */
    }
}